// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================
// ClassSelectGui.cs
// Functions for the ClassSelectDlg gui
// for selecting a class and team
//

function ClassSelectDlg::onWake(%this)
  {
   CommanderMapView.setClickingAllowed(false);
   highlightTeam();
   PickClass(ClassSelectDlg.selectedClass);
   updateGoButton();
  }

// update the commander map to display things correctly according to team
function ClassSelectDlg::onSleep(%this)
  {
   CommanderMapView.setClickingAllowed(true);
   SetTeamIcon();
   CommanderMapView.updateShowItems();
  }

// a team and class has been selected, join the game
function JoinGame()
  {
   if (ClassSelectDlg.selectedTeam > 0 && ClassSelectDlg.selectedClass > 0)
     {
      jointeam(ClassSelectDlg.selectedTeam);
      joinclass(ClassSelectDlg.selectedClass);
      // put the GUI away so player can pick a spawn point
      Canvas.popDialog(ClassSelectDlg);
     }
  }

// record the selected Team
function PickTeam(%team)
  {
   ClassSelectDlg.selectedTeam = %team;

   highlightTeam();
   updateGoButton();
  }

// record the selected class
function PickClass(%class)
  {
   ClassSelectDlg.selectedClass = %class;
   ClassGraphic.setBitmap("starter.combat/client/ui/ClassSelect" @ %class @ ".png");
   updateGoButton();
  }

function highlightTeam()
  {
   BlueTeamHighlight.setVisible(false);
   RedTeamHighlight.setVisible(false);

   if (ClassSelectDlg.selectedTeam == 1)
      RedTeamHighlight.setVisible(true);

   if (ClassSelectDlg.selectedTeam == 2)
     BlueTeamHighlight.setVisible(true);
  }

// turn on the 'go' button if team and class are selected
function updateGoButton()
  {
   if (ClassSelectDlg.selectedTeam > 0 && ClassSelectDlg.selectedClass > 0)
     GoButton.setVisible(true);
   else
     GoButton.setVisible(false);
  }

// "forget" the selected team and class
function ClassSelectDlg::resetSelections(%this)
  {
   %this.selectedTeam = 0;
   %this.selectedClass =0;
  }
