// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================

function changeWeapon(%slot)
{
commandToServer('changeWeapon', %slot);
}


// Cancel out the mouse inputs whenever we are in a car
function turretYaw(%val)
{
   $mvTurretYaw = getMouseAdjustAmount(%val);
}

function turretPitch(%val)
{
   $mvTurretPitch = getMouseAdjustAmount(%val);
}

function turretLeft(%val)
{
   $mvTurretYaw -= 0.1;
}

function turretRight(%val)
{
   $mvTurretYaw += 0.1;
}

function ApplyBrakes(%val)
{
   $mvTriggerCount2++;
}

function altTrigger(%val)
{
   $mvTriggerCount1++;
}

function toggleEngine(%val)
{
   if (%val)
      commandToServer('PowerUp');
}

//-----------------------------------------------------------------------------

// Used to flip the car over if it manages to get stuck upside down
function serverCmdflipCar(%client)
{
   %car = %client.getControlObject();

   if (%car.getClassName() $= "WheeledVehicle")
   {
      %carPos = %car.getPosition();
      %carPos = VectorAdd(%carPos, "0 0 3");

      %car.setTransform(%carPos SPC "0 0 1 0");
   }
}

// This controls how fast you turn
$turnspeed = 4;
$Forwardspeed = 2;
$Backwardspeed = 2;

// This is a global used by the functions below to track the steering angle
$steering = 0;

// As long as the "left turn" key is held down this will continue to schedule
// mvYaw adjustments to the vehicle...effectively emulating the continous
// input of a mouse instead of the on/off input of a key press
function incLeftTurn()
{
   %maxSteering = "20";
   %turn = getMouseAdjustAmount(-$turnspeed);

   $steering += %turn;
   $mvYaw    += %turn;

   if ($steering < -%maxSteering)
      $steering = -%maxSteering;

   $leftturnsched = schedule(33, 0, "incLeftTurn");
}

// As long as the "right turn" key is held down this will continue to schedule
// mvYaw adjustments to the vehicle...effectively emulating the continous
// input of a mouse instead of the on/off input of a key press
function incRightTurn()
{
   %maxSteering = "20";
   %turn = getMouseAdjustAmount($turnspeed);

   $steering += %turn;
   $mvYaw    += %turn;

   if ($steering > %maxSteering)
      $steering = %maxSteering;

   $rightturnsched = schedule(33, 0, "incRightTurn");
}

function Wheeledturnleft(%val)
{
   if (%val)
   {
      cancel($leftturnsched);
      $leftturnsched = schedule(33, 0, "incLeftTurn");
   }
   else
   {
      cancel($leftturnsched);
      if ($steering < 0)
      {
         $mvYaw += -$steering;
         $steering = 0;
      }
   }
}

function Wheeledturnright(%val)
{
   if (%val)
   {
      cancel($rightturnsched);
      $rightturnsched = schedule(33, 0, "incRightTurn");
   }
   else
   {
      cancel($rightturnsched);
      if ($steering > 0)
      {
         $mvYaw += -$steering;
         $steering = 0;
      }
   }
}

function incForward()
{
   %move = getMouseAdjustAmount(-$Forwardspeed);
   $mvForwardAction  += %move;

   $forwardsched = schedule(33, 0, "incForward");
}

function incBackward()
{
   %move = getMouseAdjustAmount(-$Backwardspeed);
   $mvBackwardAction  += %move;

   $backwardsched = schedule(33, 0, "incBackward");
}

function Wheeledmoveforward(%val)
{
   $mvForwardAction = %val * $movementSpeed;
   if (%val)
   {
      cancel($forwardsched);
      $forwardsched = schedule(100, 0, "incForward");
   }
   else
      cancel($forwardsched);
}

function Wheeledmovebackward(%val)
{
   $mvBackwardAction = %val * $movementSpeed;
   if (%val)
   {
      cancel($backwardsched);
      $backwardsched = schedule(100, 0, "incBackward");
   }
   else
      cancel($backwardsched);
}

function ClientFindNextFreeSeat(%val)
  {
   if (%val)
     {
      $mvForwardAction =0; // stop moving forward when switching seats
      commandToServer('FindNextFreeSeat');
     }
  }
