//-----------------------------------------------------------------------------
// Torque Game Engine
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

if ( isObject( moveMap ) )
   moveMap.delete();
new ActionMap(moveMap);


//------------------------------------------------------------------------------
// Non-remapable binds
//------------------------------------------------------------------------------

function escapeFromGame()
{
   if ( $Server::ServerType $= "SinglePlayer" )
      MessageBoxYesNo( "Quit Mission", "Exit from this Mission?", "disconnect();", "");
   else
      MessageBoxYesNo( "Disconnect", "Disconnect from the server?", "disconnect();", "");
}



function showPlayerList(%val)
{
   //if (%val)
   //   PlayerListGui.toggle();
   if (%val)
     ScoreboardGui.toggle();
}

moveMap.bind( keyboard, F5, toggleParticleEditor);

// Added for player jetting start
function mouseJet(%val)
{
	$mvTriggerCount1++;
}
moveMap.bind(mouse, "button3", mouseJet);
// Added for player jetting end
//------------------------------------------------------------------------------
// Movement Keys
//------------------------------------------------------------------------------

$movementSpeed = 1; // m/s

function setSpeed(%speed)
{
   if(%speed)
      $movementSpeed = %speed;
}

function moveleft(%val)
{
   $mvLeftAction = %val * $movementSpeed;
}

function moveright(%val)
{
   $mvRightAction = %val * $movementSpeed;
}

function moveforward(%val)
{
   $mvForwardAction = %val * $movementSpeed;
}

function movebackward(%val)
{
   $mvBackwardAction = %val * $movementSpeed;
}

function moveup(%val)
{
   $mvUpAction = %val * $movementSpeed;
}

function movedown(%val)
{
   $mvDownAction = %val * $movementSpeed;
}

function turnLeft( %val )
{
   $mvYawRightSpeed = %val ? $Pref::Input::KeyboardTurnSpeed : 0;
}

function turnRight( %val )
{
   $mvYawLeftSpeed = %val ? $Pref::Input::KeyboardTurnSpeed : 0;
}

function panUp( %val )
{
   $mvPitchDownSpeed = %val ? $Pref::Input::KeyboardTurnSpeed : 0;
}

function panDown( %val )
{
   $mvPitchUpSpeed = %val ? $Pref::Input::KeyboardTurnSpeed : 0;
}

function getMouseAdjustAmount(%val)
{
   // based on a default camera fov of 90'
   return(%val * ($cameraFov / 90) * 0.01);
}

function yaw(%val)
{
   $mvYaw += getMouseAdjustAmount(%val);
}

function pitch(%val)
{
   $mvPitch += getMouseAdjustAmount(%val);
}

function jump(%val)
 {
  $mvTriggerCount2 += $mvTriggerCount2 & 1 == %val ? 2 : 1;
 }

moveMap.bind( keyboard, a, moveleft );
moveMap.bind( keyboard, d, moveright );
moveMap.bind( keyboard, w, moveforward );
moveMap.bind( keyboard, s, movebackward );
moveMap.bind( keyboard, space, jump );
moveMap.bind( mouse, xaxis, yaw );
moveMap.bind( mouse, yaxis, pitch );


//------------------------------------------------------------------------------
// Mouse Trigger
//------------------------------------------------------------------------------

function mouseFire(%val)
  {
   $mvTriggerCount0 += $mvTriggerCount0 & 1 == %val ? 2 : 1;
  }

function altTrigger(%val)
  {
   $mvTriggerCount1 += $mvTriggerCount1 & 1 == %val ? 2 : 1;
  }

moveMap.bind( mouse, button0, mouseFire );
moveMap.bind( mouse, button2, toggleZoom );
moveMap.bind( mouse, button1, toggleZoom );

//------------------------------------------------------------------------------
// Zoom and FOV functions
//------------------------------------------------------------------------------



if($Pref::player::CurrentFOV $= "")
   $Pref::player::CurrentFOV = 45;

function clientCmdZoomIn( %val, %curWeapon )
{
   if (%val) {
      switch$(%curWeapon)
      {
         case "Rifle":
            $ZoomOn = true;
            $Pref::player::CurrentFOV = 18;
            setFov( $Pref::player::CurrentFOV );
            ScopeGuiGroup.bitmap = "starter.combat/client/ui/scope01.png";
            ScopeGuiGroup.Visible = 1; // Show Scope HUD
            Crosshair.Visible = 0; // Hide Crosshair
            customCrosshair.Visible = 0; // Hide Custom Crosshair
         case "SniperRifle":
            $ZoomOn = true;
            //$Pref::player::CurrentFOV = 11.25;
            $Pref::player::CurrentFOV = 10;
            setFov( $Pref::player::CurrentFOV );
            ScopeGuiGroup.bitmap = "starter.combat/client/ui/sniperscope.png";
            ScopeGuiGroup.Visible = 1; // Show Scope HUD

            Crosshair.Visible = 0; // Hide Crosshair
            customCrosshair.Visible = 0; // Hide Custom Crosshair
         case "AssaultRifle":
            $ZoomOn = true;
            $Pref::player::CurrentFOV = 22.5;
            setFov( $Pref::player::CurrentFOV );
            ScopeGuiGroup.bitmap = "starter.combat/client/ui/scope01.png";
            ScopeGuiGroup.Visible = 1; // Show Scope HUD

            Crosshair.Visible = 0; // Hide Crosshair
            customCrosshair.Visible = 0; // Hide Custom Crosshair
         case "RocketLauncher":
            $ZoomOn = true;
            $Pref::player::CurrentFOV = 11.25;
            setFov( $Pref::player::CurrentFOV );
            ScopeGuiGroup.bitmap = "starter.combat/client/ui/scope02.png";
            ScopeGuiGroup.Visible = 1; // Show Scope HUD

            Crosshair.Visible = 0; // Hide Crosshair
            customCrosshair.Visible = 0; // Hide Custom Crosshair
      }
   }
   else
   {
      $ZoomOn = false;
      setFov( $Pref::player::DefaultFov );
      ScopeGuiGroup.Visible = 0; // turn off the scope HUD
   }
}
function toggleZoom(%val)
{
   if ($firstPerson == 1) // No Zoom When in 3rd Person View
   {
      commandToServer( 'CallZoomFunction', %val );

   }
}

function clientCmdAreYouZoomed()
  {
   if ($zoomOn)
     {
      commandToServer('RLZoomCheckReply', 1);
     }
  }

// change RL scope to indicate target lock
function clientCmdSetTargetLock()
  {
   if (ScopeGuiGroup.Visible == 1)
     {
      ScopeGuiGroup.bitmap = "starter.combat/client/ui/scope07.png";
     }
  }

// restore origional RL scope
function clientCmdRemoveTargetLock()
  {
   if (ScopeGuiGroup.Visible == 1)
     {
      ScopeGuiGroup.bitmap = "starter.combat/client/ui/scope02.png";
     }
  }
//moveMap.bind(keyboard, r, setZoomFOV);


//------------------------------------------------------------------------------
// Camera & View functions
//------------------------------------------------------------------------------

function toggleFreeLook( %val )
{
   if ( %val ) $mvFreeLook = (!$mvFreeLook);
}

$firstPerson = true;
function toggleFirstPerson(%val)
{
   if (%val)
   {
      $firstPerson = !$firstPerson;
      ServerConnection.setFirstPerson($firstPerson);
      updateCameraMode();
   }
}

function toggleCamera(%val)
{
   if (%val)
      commandToServer('ToggleCamera');
}

function repairVehicle(%val)
{
   if (%val)
      commandToServer('repairVehicle');
}
moveMap.bind( keyboard, "x", repairVehicle );

function ReloadWeapon(%val)
{
   if (%val)
      commandToServer('WeaponReload');
}



moveMap.bind( keyboard, "home", toggleFreeLook );
moveMap.bind(keyboard, tab, toggleFirstPerson );
moveMap.bind(keyboard, "alt c", toggleCamera);
moveMap.bindCmd(keyboard, "1", "commandToServer(\'ChangeWeapon\', 1);", "");
moveMap.bindCmd(keyboard, "2", "commandToServer(\'ChangeWeapon\', 2);", "");
moveMap.bindCmd(keyboard, "3", "commandToServer(\'ChangeWeapon\', 3);", "");
moveMap.bindCmd(keyboard, "4", "commandToServer(\'ChangeWeapon\', 4);", "");
moveMap.bindCmd(keyboard, "5", "commandToServer(\'ChangeWeapon\', 5);", "");


//------------------------------------------------------------------------------
// Misc. Player stuff
//------------------------------------------------------------------------------

moveMap.bindCmd(keyboard, "ctrl w", "commandToServer('playCel',\"wave\");", "");
moveMap.bindCmd(keyboard, "ctrl s", "commandToServer('playCel',\"salute\");", "");


//------------------------------------------------------------------------------
// Item manipulation
//------------------------------------------------------------------------------

moveMap.bindCmd(keyboard, "h", "commandToServer('use',\"HealthKit\");", "");

// Rob - Commented this out, because 1 is now an item slot, not sure what it was used
// for but if it's a cross bow it can't be important?
//moveMap.bindCmd(keyboard, "1", "commandToServer('use',\"Crossbow\");", "");

moveMap.bindCmd(keyboard, "g", "commandToServer(\'throwGrenade\');", "");
//------------------------------------------------------------------------------
// Message HUD functions
//------------------------------------------------------------------------------

function pageMessageHudUp( %val )
{
   if ( %val )
      pageUpMessageHud();
}

function pageMessageHudDown( %val )
{
   if ( %val )
      pageDownMessageHud();
}

function resizeMessageHud( %val )
{
   if ( %val )
      cycleMessageHudSize();
}



//------------------------------------------------------------------------------
// Demo recording functions
//------------------------------------------------------------------------------

function startRecordingDemo( %val )
{
   if ( %val )
      startDemoRecord();
}

function stopRecordingDemo( %val )
{
   if ( %val )
      stopDemoRecord();
}

moveMap.bind( keyboard, F3, startRecordingDemo );
moveMap.bind( keyboard, F4, stopRecordingDemo );


//------------------------------------------------------------------------------
// Helper Functions
//------------------------------------------------------------------------------

function dropCameraAtPlayer(%val)
{
   if (%val)
      commandToServer('dropCameraAtPlayer');
}

function dropPlayerAtCamera(%val)
{
   if (%val)
      commandToServer('DropPlayerAtCamera');
}

moveMap.bind(keyboard, "F8", dropCameraAtPlayer);
moveMap.bind(keyboard, "F7", dropPlayerAtCamera);

function bringUpOptions(%val)
{
   if (%val)
      Canvas.pushDialog(OptionsDlg);
}

moveMap.bind(keyboard, "ctrl o", bringUpOptions);


//------------------------------------------------------------------------------
// Dubuging Functions
//------------------------------------------------------------------------------

$MFDebugRenderMode = 0;
function cycleDebugRenderMode(%val)
{
   if (!%val)
      return;

   if (getBuildString() $= "Debug")
   {
      if($MFDebugRenderMode == 0)
      {
         // Outline mode, including fonts so no stats
         $MFDebugRenderMode = 1;
         GLEnableOutline(true);
      }
      else if ($MFDebugRenderMode == 1)
      {
         // Interior debug mode
         $MFDebugRenderMode = 2;
         GLEnableOutline(false);
         setInteriorRenderMode(7);
         showInterior();
      }
      else if ($MFDebugRenderMode == 2)
      {
         // Back to normal
         $MFDebugRenderMode = 0;
         setInteriorRenderMode(0);
         GLEnableOutline(false);
         show();
      }
   }
   else
   {
      echo("Debug render modes only available when running a Debug build.");
   }
}

GlobalActionMap.bind(keyboard, "F9", cycleDebugRenderMode);


//------------------------------------------------------------------------------
// Misc.
//------------------------------------------------------------------------------

GlobalActionMap.bind(keyboard, "tilde", toggleConsole);
GlobalActionMap.bindCmd(keyboard, "alt k", "cls();","");
GlobalActionMap.bindCmd(keyboard, "alt enter", "", "toggleFullScreen();");
GlobalActionMap.bindCmd(keyboard, "F1", "", "contextHelp();");

moveMap.bindCmd(keyboard, "n", "NetGraph::toggleNetGraph();", "");

function showCommanderMap(%val)
{
   if (%val)
      toggleCommanderMapGui();
}

function changePlayerPosition(%val)
  {
   if (%val)      // calling it with a 0 will bump us up to the next position
   CommandtoServer('SetPlayerPos', 0);
  }


// add the chat key binds to the movemap
function AddChatBinds(%moveMap)
  {
   %moveMap.bind(keyboard, "return", toggleMessageHud );
   %moveMap.bind(keyboard, t, teamMessageHud );
   %moveMap.bind(keyboard, "pageUp", pageMessageHudUp );
   %moveMap.bind(keyboard, "pageDown", pageMessageHudDown );
   %moveMap.bind(keyboard, "p", resizeMessageHud );
  }

function AddBasicKeyBinds(%moveMap)
  {
   %moveMap.bindCmd(keyboard, "escape", "", "escapeFromGame();");
   %moveMap.bind( keyboard, F2, showPlayerList );
   %moveMap.bind( keyboard, "m", showCommanderMap );
   %moveMap.bindCmd(keyboard, "control k", "commandtoserver(\'Suicide\');", "");
  }

function AddBasicPlayerKeyBinds(%moveMap)
  {
   %moveMap.bindCmd(keyboard, "e", "commandToServer(\'MountVehicle\');", "");
   %moveMap.bind( keyboard, space, jump );
   %moveMap.bindCmd(keyboard, "q", "commandToServer(\'switchMode\');", "");
   %moveMap.bind( keyboard, c, changePlayerPosition );
   %moveMap.bind( keyboard, "r", ReloadWeapon);
   %moveMap.bind( mouse, mouse2, toggleZoom);
   %moveMap.bind( keyboard, tab, toggleFirstPerson);
  }

function AddVehicleKeyBinds(%moveMap)
  {
   %moveMap.bind( keyboard, "q", ClientFindNextFreeSeat);
   %moveMap.bindCmd(keyboard, "e", "commandToServer(\'DismountVehicle\');", "");
   %moveMap.bindCmd(keyboard, "control k", "commandtoserver(\'Suicide\');", "");
   %moveMap.bind( keyboard, tab, toggleCameraMode);
  }

AddChatBinds(moveMap);
AddBasicKeyBinds(moveMap);
AddBasicPlayerKeyBinds(moveMap);
