// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================

// created by Duncan Gray


// camera mode 0 is for 3rd person view
// camera mode 1 is for 1st person view
// camera mode > 1 is for any weapon views you wish to use
// each vehicle must set the $weaponViews variable to suit its situation
// the code assumes that weapon views correspond to image slots in use
// and that image slots are numbered sequencially from 0 upwards
// example $weaponViews = 4 means you have weapons mounted on slots
// 0 through slot 3

// this is to correspond to the code with how the vehicle.cc getCameraTransform
// has been changed to use use different camera views


$Gui_Vehicle = 0;
$Gui_Heli = 1;
$Gui_Jeep = 2;

function toggleCameraMode(%val)
{

   if(heliDriverMap.active==true || heliPassengerMap.active==true)
   {
      //Temporarily disabled for lockup on high end machines...
      return;
   }

   if (%val)
   {
      $CameraMode ++;
      if($CameraMode > 1 + $weaponViews)
        $CameraMode=0;

      $firstPerson = 1;
      if($CameraMode==0)
         $firstPerson = 0;

      ServerConnection.setFirstPerson($firstPerson);

      if ($firstPerson == 0)
        {
         %tmp1 = $showDialsGlobal;
         %tmp2 = $crosshairImageGlobal;
         camera::SetGui(0, "none");
         $showDialsGlobal = %tmp1;
         $crosshairImageGlobal = %tmp2;
        }
      else
      {
        camera::SetGui($showDialsGlobal, $crosshairImageGlobal);
      }
   }
}

function camera::SetGui(%showDials, %crosshairImage)
  {
   if (%showDials==1)
     camera::replaceDials();
   else
     camera::removeDials();
   if (strlen(%crosshairImage) == 0)
     %crosshairImage = "none";

   if (%crosshairImage $= "none")
     TurretScope.Visible = false;
   else
    {
     TurretScope.bitmap = "~/client/ui/" @ %crosshairImage;
     TurretScope.Visible = true;
    }
   $showDialsGlobal = %showDials;
   $crosshairImageGlobal = %crosshairImage;
}

$cameraDials = -1;
function camera::removeDials()
{
  if($cameraDials == 0)
    return;

  if($GuiInUse[$Gui_Vehicle, 0])
     GenericDriverMap::removeGui(); // remove dials
  if($GuiInUse[$Gui_Heli, 0])
     heliDriverMap::removeGui(); // remove dials
  if($GuiInUse[$Gui_Heli, 3] == 0)
     heliDriverMap::removeAmmo(); // remove dials

  $cameraDials = 0;
}

function camera::replaceDials()
{

  if($cameraDials == 1)
    return;

  if($GuiInUse[$Gui_Vehicle, 0]){
     %node = $GuiInUse[$Gui_Vehicle, 1];
     %vehicle = $GuiInUse[$Gui_Vehicle, 2];
     %turret = $GuiInUse[$Gui_Vehicle, 3];
     clientCmdCreateGenericVehicleGui(1, %node, %vehicle, %turret);
  }
  if($GuiInUse[$Gui_Heli, 0]){
     %node = $GuiInUse[$Gui_Heli, 1];
     %vehicle = $GuiInUse[$Gui_Heli, 2];
     %turret = $GuiInUse[$Gui_Heli, 3];
     clientCmdCreateHeliVehicleGui(1, %node, %vehicle, %turret);
  }
  $cameraDials = 1;
}

