// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================

//Rob - Vehicle Targetting
//Datablock for the image which appears on pilot clients GUI
new GuiBitmapCtrl(vehicleTargetted) {
   canSaveDynamicFields = "0";
   Profile = "GuiDefaultProfile";
   HorizSizing = "right";
   VertSizing = "bottom";
   position = (getWord(PlayGui.extent, 0) / 2 - 125) SPC (getWord(PlayGui.extent, 1) / 2) ;
   Extent = "250 100";
   MinExtent = "8 2";
   canSave = "1";
   Visible = "1";
   hovertime = "1000";
   bitmap = "~/client/ui/vehicleTargetted.png";
   wrap = "0";
};

// This function is called on the pilots client by the server
// When an enemy rocket launcher is aimed straight at it. If
// the pilot is already being warned, it flags the message to continue
// once again, if not it starts a loop.
function clientCMDvehicleTargetted()
{
	//If our vehicle is not already being targetted by a different launcher
	if(!$vehicleIsTargetted) {vehicletargetteddisplay();} // Then warn pilot

	//If we are already being warned, don't spawn another image, just flag
	//the loop to continue.
	else {$vehicleIsStillTargetted = 1;}
}


// Called after a flashing loop has been completed. If we have been targetted
// since the last loop we flash it again. If not we set the vehicle as no longer
// being targetted.
function VehicleTargettedReloop()
{

	if($vehicleIsStilltargetted)
		{
			vehicletargetteddisplay();
			$vehicleIsStilltargetted = false;
		}

	else
		{
			$vehicleIsTargetted = false;
		}
}

// This function actually displays the warning, sounds an alarm and schedules the image
// to be deleted in 0.5 seconds.
function vehicleTargettedDisplay()
{
	PlayGui.add(vehicleTargetted);
	alxPlay(AudioCountBeep);
	$vehicleIsTargetted = true;
	schedule(1000, 0, vehicleTargettedDelete);
}

// This function deletes the image and schedules a check to see if we have had any more warnings
// In the last 0.5 seconds.
function vehicleTargettedDelete()
{
	PlayGui.remove(vehicleTargetted);
	schedule(1000, 0, vehicletargettedReloop);


}
