// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================
//AV Mine

//-----------------------------------------------------------------------------

datablock AudioProfile(C4ReloadSound)
{
filename = "~/data/sound/crossbow_reload.ogg";
description = AudioClose3d;
preload = true;
};

datablock AudioProfile(C4FireSound)
{
filename = "~/data/sound/explosion02_4.ogg";
description = SAudioDefault3d;
preload = true;
};

datablock AudioProfile(C4FireEmptySound)
{
filename = "~/data/sound/crossbow_firing_empty.ogg";
description = AudioClose3d;
preload = true;
};

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Projectile mine
datablock ProjectileData(C4Projectile)
{
   projectileShapeName = "~/data/shapes/crossbow/projectile.dts";
   directDamage        = 1000;
   radiusDamage        = 1000;
   damageRadius        = 20;
   areaImpulse         = 400;           // if this gets too high, it will freeze the server
   explosion           = C4Explosion;
   splash              = BulletSplash;

   muzzleVelocity      = 0;
   velInheritFactor    = 0.3;

   armingDelay         = 0;
   lifetime            = 9999;
   fadeDelay           = 1;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0.8 0.4 0 0.8";

   hasWaterLight     = true;
   waterLightColor   = "0.8 0.4 0 0.8";
};

// Ammo Item

datablock ItemData(C4Ammo)
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "~/data/shapes/combat/c4exp.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   // Dynamic properties defined by the scripts
   pickUpName = "C4 Charges";
   maxInventory = 10;
};


//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.  When the weapon
// is mounted onto a shape, the CrossbowImage is used.

datablock ItemData(C4)
{
   // Mission editor category
   category = "Weapon";

   // Hook into Item Weapon class hierarchy. The weapon namespace
   // provides common weapon handling functions in addition to hooks
   // into the inventory system.
   className = "Weapon";

   // Basic Item properties
   shapeFile = "~/data/shapes/combat/c4exp.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   // Dynamic properties defined by the scripts
   pickUpName = "a C4 Charge";
   modes = 2;
   image = C4Image;
   image2 = C42Image;

};


//--------------------------------------------------------------------------
// Crossbow image which does all the work.  Images do not normally exist in
// the world, they can only be mounted on ShapeBase objects.

datablock ShapeBaseImageData(C4Image)
{
   // Basic Item properties

   shapeFile = "~/data/shapes/combat/c4exp.dts";
   emap = true;
   imageNum = 1;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   eyeOffset = "0.1 0.3 -0.45";
   crosshair = "crossHair2.png";
   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = C4;
   ammo = C4Ammo;
   projectile = C4Projectile;
   projectileType = Projectile;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the weapon is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.6;
   stateSequence[1]                 = "Activate";

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   // Fire the weapon. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.2;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3]                    = C4FireSound;

   // Play the relead animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.8;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;
   stateSound[4]                    = C4ReloadSound;

   // No ammo in the weapon, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";
   stateScript[5]                   = "onNoAmmo";

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
   stateSound[6]                    = C4FireEmptySound;
};

datablock ShapeBaseImageData(C42Image)
{
   // Basic Item properties

   shapeFile = "~/data/shapes/combat/det.dts";
   emap = true;
   imageNum = 2;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   eyeOffset = "0.1 0.63 -0.3";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = C4;
   ammo = C4Ammo;
   //projectile = not used
   //projectileType = not used

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   //stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the weapon is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.6;
   stateSequence[1]                 = "Activate";

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnTriggerDown[2]  = "Fire";

   // Fire the weapon. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.1;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";

   // Play the relead animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;
};
//-----------------------------------------------------------------------------

function C4Image::onFire(%this, %obj, %slot)
{
   %obj.decInventory(%this.ammo,1);
   %obj.throw(C4Live,1);
}

function C4Image::onNoAmmo(%this, %obj, %slot)
{
   %obj.SwitchMode();
}

function C42Image::onFire(%this, %obj, %slot)
{
   %position = %obj.getTransform();
   InitContainerRadiusSearch(%position, 500, $TypeMasks::ItemObjectType);
   while ((%targetObject = containerSearchNext()) != 0)
   {
     if(%targetObject.getDataBlock().getName() $= "C4Live")
     {
        if(%targetObject.client == %obj.client)
        {
           C4Detonate(%targetObject);
        }
     }
   }
}
//-----------------------------------------------------------------------------
// Mines cannot be picked up and are not meant to be added to
// inventory.
//-----------------------------------------------------------------------------

datablock ItemData(C4Live)
{
   // Mission editor category, this datablock will show up in the
   // specified category under the "shapes" root category.
   category = "Live";

   // Basic Item properties
   shapeFile = "~/data/shapes/combat/c4_live.dts";
   mass = 1;
   friction = 1;
   elasticity = 0.3;
   emap = true;
   sticky = true;

   // Dynamic properties defined by the scripts
   maxInventory = 0; // No pickup or throw
   throwable = "1";  // lets this item be thrown
};

function C4Detonate(%obj)
{
   %pos = %obj.getTransform();
   radiusDamage(%obj,%pos,C4Projectile.damageRadius,C4Projectile.radiusDamage,C4Projectile.getName(), C4Projectile.areaImpulse);
   %projectile = new (projectile)()
   {
         dataBlock = C4Projectile;
         initialVelocity  = 0;
         initialposition = %pos;
         client = %obj.client;
    };
    MissionCleanup.add(%projectile);
    %obj.delete();

}
