// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================
//  Central file for all explosion related data

datablock AudioProfile(RocketLauncherExplosionSound)
  {
   filename = "~/data/sound/combat/explode.ogg";
   description = AudioDefault3d;
   preload = true;
  };

datablock AudioProfile(AssaultGrenadeExplosionSound)
  {
   filename = "~/data/sound/combat/AssaultGrenBoom.ogg";
   description = AudioClose3d;
   preload = true;
  };

datablock ParticleData(M60SmokeParticle)
{
   textureName          = "~/data/shapes/particles/smoke";

   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.2;  // rises
   inheritedVelFactor   = 0.00;

   lifetimeMS           = 300;   // time in ms
   lifetimeVarianceMS   = 150;   // ...more or less

   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "0 0 0 0";

   sizes[0]      = 0.1;
   sizes[1]      = 0.15;
   sizes[2]      = 0.3;

   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(M60SmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 5;

   ejectionVelocity = 0.25;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   particles = M60SmokeParticle;
};

datablock ParticleData(FireParticles)
{
   textureName          = "~/data/shapes/particles/fire";

   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -1.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 200;
   useInvAlpha =  true;
   spinRandomMin = -60.0;
   spinRandomMax =  60.0;

   colors[0]     = "1.0 0.9 0.8 1.0";
   colors[1]     = "0.8 0.4 0 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 4.5;
   sizes[1]      = 18.0;
   sizes[2]      = 9.5;

   times[0]      = 0.0;
   times[1]      = 0.35;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ExplosionFireEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 5;
   ejectionVelocity = 3;
   velocityVariance = 2;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;

   particles = FireParticles;
};

datablock ParticleData(FireballParticles)
{
   textureName          = "~/data/shapes/particles/fire";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 100;
   useInvAlpha =  false;
   spinRandomMin = -180.0;
   spinRandomMax =  180.0;

   colors[0]     = "1.0 0.9 0.8 1";
   colors[1]     = "1.0 0.4 0 1";
   colors[2]     = "0.0 0.0 0.0 1";

   sizes[0]      = 4.5;
   sizes[1]      = 18.0;
   sizes[2]      = 9.5;

   times[0]      = 0.0;
   times[1]      = 0.35;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ExplosionFireball)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 5;
   ejectionVelocity = 3;
   velocityVariance = 2;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   particles = FireballParticles;
};

datablock ParticleData(TankFireballParticles)
{
   textureName          = "~/data/shapes/particles/fire";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.1;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 100;
   useInvAlpha =  false;
   spinRandomMin = -180.0;
   spinRandomMax =  180.0;

   colors[0]     = "1.0 0.9 0.8 1";
   colors[1]     = "1.0 0.4 0 1";
   colors[2]     = "0.0 0.0 0.0 1";

   sizes[0]      = 4.5;
   sizes[1]      = 15.0;
   sizes[2]      = 20.0;

   times[0]      = 0.0;
   times[1]      = 0.35;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(TankExplosionFireball)
{
   ejectionPeriodMS = 50;
   periodVarianceMS = 5;
   ejectionVelocity = 3;
   velocityVariance = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   particles = TankFireballParticles;
};


datablock ParticleData(ExplosionSmoke)
{
   textureName          = "~/data/shapes/particles/smoke";

   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -1.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 200;
   useInvAlpha =  true;
   spinRandomMin = -60.0;
   spinRandomMax =  60.0;

   colors[0]     = "0.1 0.1 0.1 1.0";
   colors[1]     = "0.5 0.5 0.5 0.8";
   colors[2]     = "0.8 0.7 0.6 0.2";

   sizes[0]      = 3.0;
   sizes[1]      = 12.0;
   sizes[2]      = 20.0;

   times[0]      = 0.0;
   times[1]      = 0.75;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ExplosionSmokeEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   ejectionVelocity = 4.0;
   velocityVariance = 2.0;
   thetaMin         = 0.0;
   thetaMax         = 10.0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   //ejectionoffset   = 3;

   particles = "ExplosionSmoke";
};

datablock ParticleEmitterData(WideExplosionSmokeEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   ejectionVelocity = 4.8;
   velocityVariance = 2.0;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   ejectionOffset   = 5;
   particles = "ExplosionSmoke";
};

datablock ParticleData(ExplosionSparks)
{
   textureName          = "~/data/shapes/particles/spark";
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.4;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 50;
   useInvAlpha =  false;
   spinRandomMin = -0.0;
   spinRandomMax =  0.0;

   colors[0]     = "1.0 0.9 0.8 0.2";
   colors[1]     = "1.0 0.9 0.8 0.8";
   colors[2]     = "0.8 0.4 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 4.0;
   sizes[2]      = 1.0;

   times[0]      = 0.0;
   times[1]      = 0.35;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ExplosionSparkEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 2;
   ejectionVelocity = 60;
   velocityVariance = 4;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   orientParticles  = true;
   orientOnVelocity = true;
   particles = "ExplosionSparks";
};

datablock ExplosionData(SubExplosion1)
{
   offset = 0.6;
   lifeTimeMS = 100;
   emitter[0] = ExplosionFireball;
};

datablock ExplosionData(SubExplosion2)
{
   offset = 1.0;
   lifeTimeMS = 100;
   emitter[0] = ExplosionFireball;
   emitter[1] = ExplosionSparkEmitter;
};

// Debris smoke trail
datablock ParticleData(DebrisTrail)
{
   textureName          = "~/data/shapes/particles/fire";
   dragCoefficient      = 1;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   windCoefficient      = 0;
   constantAcceleration = 0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 100;
   spinSpeed     = 0;
   spinRandomMin = -90.0;
   spinRandomMax =  90.0;
   useInvAlpha   = true;

   colors[0]     = "0.8 0.3 0.0 1.0";
   colors[1]     = "0.1 0.1 0.1 0.7";
   colors[2]     = "0.1 0.1 0.1 0.0";

   sizes[0]      = 0.2;
   sizes[1]      = 0.3;
   sizes[2]      = 0.4;

   times[0]      = 0.1;
   times[1]      = 0.2;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(DebrisTrailEmitter)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 170;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   //overrideAdvances = false;
   //orientParticles  = true;
   lifetimeMS       = 5000;
   particles = "DebrisTrail";
};

datablock ParticleData(DebrisSpark)
{
   textureName          = "~/data/shapes/particles/fire";
   dragCoefficient      = 0;
   gravityCoefficient   = 0.0;
   windCoefficient      = 0;
   inheritedVelFactor   = 0.5;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 50;
   spinRandomMin = -90.0;
   spinRandomMax =  90.0;
   useInvAlpha   = false;

   colors[0]     = "0.8 0.2 0 1.0";
   colors[1]     = "0.8 0.2 0 1.0";
   colors[2]     = "0 0 0 0.0";

   sizes[0]      = 0.2;
   sizes[1]      = 0.3;
   sizes[2]      = 0.1;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(DebrisSparkEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   velocityVariance = 0.25;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 300;
   particles = "DebrisSpark";
};

datablock ExplosionData(DebrisExplosion)
{
   emitter[0] = DebrisSparkEmitter;

   // Turned off..
   shakeCamera = false;
   impulseRadius = 0;
   lightStartRadius = 0;
   lightEndRadius = 0;
};

datablock DebrisData(ExplosionDebris)
{
   shapeFile = "~/data/shapes/crossbow/debris.dts";
   emitters = "DebrisTrailEmitter";
   explosion = DebrisExplosion;

   elasticity = 0.6;
   friction = 0.5;
   numBounces = 2;
   bounceVariance = 1;
   explodeOnMaxBounce = true;
   staticOnMaxBounce = false;
   snapOnMaxBounce = false;
   minSpinSpeed = 0;
   maxSpinSpeed = 700;
   render2D = false;
   lifetime = 40;
   lifetimeVariance = 0.4;
   //velocity = 20;
   //velocityVariance = 0.5;
   fade = true;
   useRadiusMass = true;
   baseRadius = 0.3;
   gravModifier = 0.5;
   terminalVelocity = 0;
   ignoreWater = true;
};

datablock ParticleData( BulletSplashParticle )
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -1.4;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 20;
   textureName          = "~/data/shapes/chaingun/textures/droplet";
   colors[0]     = "0.7 0.8 1.0 1.0";
   colors[1]     = "0.7 0.8 1.0 0.5";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.05;
   sizes[1]      = 0.2;
   sizes[2]      = 0.2;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleData(ShellSparks)
{
   textureName          = "~/data/shapes/particles/spark";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.4;
   constantAcceleration = 0.0;
   lifetimeMS           = 250;
   lifetimeVarianceMS   = 100;
   useInvAlpha =  false;
   spinRandomMin = -0.0;
   spinRandomMax =  0.0;

   colors[0]     = "1.0 0.9 0.8 0.2";
   colors[1]     = "1.0 0.9 0.8 0.55";
   colors[2]     = "0.8 0.4 0.0 0.0";

   sizes[0]      = 2.0;
   sizes[1]      = 6.0;
   sizes[2]      = 2.0;

   times[0]      = 0.0;
   times[1]      = 0.35;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ShellSparksEmitter)
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 2;
   ejectionVelocity = 60;
   velocityVariance = 4;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   orientParticles  = true;
   orientOnVelocity = true;

   particles = "ShellSparks";
};

datablock ParticleEmitterData( BulletSplashEmitter )
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 50;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 150;
   particles = "BulletSplashParticle";
};


datablock SplashData(BulletSplash)
{
   numSegments = 10;
   ejectionFreq = 10;
   ejectionAngle = 20;
   ringLifetime = 0.4;
   lifetimeMS = 100;
   velocity = 3.0;
   startRadius = 0.0;
   acceleration = -3.0;
   texWrap = 5.0;

   texture = "~/data/shapes/chaingun/textures/water2";

   emitter[0] = BulletSplashEmitter;

   colors[0] = "0.7 0.8 1.0 0.0";
   colors[1] = "0.7 0.8 1.0 1.0";
   colors[2] = "0.7 0.8 1.0 0.0";
   colors[3] = "0.7 0.8 1.0 0.0";
   times[0] = 0.0;
   times[1] = 0.4;
   times[2] = 0.8;
   times[3] = 1.0;
};


datablock ExplosionData(RocketLauncherExplosion)
{
   soundProfile = RocketLauncherExplosionSound;
   lifeTimeMS = 100;

   // Volume particles
   particleEmitter = WideExplosionSmokeEmitter;
   particleDensity = 15;
   particleRadius = 1;

   // Point emission
   emitter[0] = ExplosionFireEmitter;
   emitter[1] = ExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = SubExplosion1;
   subExplosion[1] = SubExplosion2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 1.5;
   camShakeRadius = 10.0;

   // Exploding debris
   debris = ExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 60;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 6;
   debrisNumVariance = 2;
   debrisVelocity = 5;
   debrisVelocityVariance = 0.5;

   // Impulse
   impulseRadius = 10;
   impulseForce = 15;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(AssaultGrenadeExplosion)
{
   soundProfile = AssaultGrenadeExplosionSound;
   lifeTimeMS = 1000;

   // Volume particles
   particleEmitter = ExplosionSmokeEmitter;
   particleDensity = 30;
   particleRadius = 1.5;

   // Point emission
   emitter[0] = ExplosionFireEmitter;
   //emitter[1] = ExplosionSparkEmitter;

   // Sub explosion objects
   //subExplosion[0] = SubExplosion1;
   //subExplosion[1] = SubExplosion2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Impulse
   impulseRadius = 10;
   impulseForce = 15;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(GrenadeExplosion)
{
   soundProfile = AssaultGrenadeExplosionSound;
   lifeTimeMS = 120;

   // Volume particles
   particleEmitter = ExplosionSmokeEmitter;

   particleDensity = 10;
   particleRadius = 1;

   // Point emission
   emitter[0] = ExplosionFireball;
   emitter[1] = ExplosionSparkEmitter;
   emitter[2] = ExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = SubExplosion1;
   subExplosion[1] = SubExplosion2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Exploding debris
   debris = ExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 70;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 12;
   debrisNumVariance = 2;
   debrisVelocity = 5;
   debrisVelocityVariance = 2;

   // Impulse
   impulseRadius = 10;
   impulseForce = 15;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(C4Explosion)
{
   soundProfile = AssaultGrenadeExplosionSound;
   lifeTimeMS = 100;

   // Volume particles
   particleEmitter = ExplosionFireEmitter;
   particleDensity = 20;
   particleRadius = 1;

   // Point emission
   emitter[0] = ExplosionSmokeEmitter;
   emitter[1] = ExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = SubExplosion1;
   subExplosion[1] = SubExplosion2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Exploding debris
   debris = ExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 70;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 12;
   debrisNumVariance = 2;
   debrisVelocity = 5;
   debrisVelocityVariance = 2;

   // Impulse
   impulseRadius = 10;
   impulseForce = 15;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(TurretExplosion)
{
   soundProfile = AssaultGrenadeExplosionSound;
   lifeTimeMS = 1200;

   // Volume particles
   particleEmitter = ExplosionFireEmitter;
   particleDensity = 75;
   particleRadius = 2;

   // Point emission
   emitter[0] = ExplosionSmokeEmitter;
   emitter[1] = ExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = SubExplosion1;
   subExplosion[1] = SubExplosion2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Exploding debris
   debris = ExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 70;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 12;
   debrisNumVariance = 2;
   debrisVelocity = 5;
   debrisVelocityVariance = 2;

   // Impulse
   impulseRadius = 10;
   impulseForce = 15;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(TankShellExplosion)
{
   soundProfile = AssaultGrenadeExplosionSound;
   lifeTimeMS = 150;

   // Volume particles
   particleEmitter = WideExplosionSmokeEmitter;
   particleDensity = 25;
   particleRadius = 1.5;

   // Point emission
   emitter[0] = TankExplosionFireball;
   emitter[1] = ShellSparksEmitter;
   emitter[2] = ExplosionFireEmitter;
   emitter[3] = ShellSparksEmitter;

   // Exploding debris
   debris = ExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 30;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 20;
   debrisNumVariance = 10;
   debrisVelocity = 10;
   debrisVelocityVariance = 2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Impulse
   impulseRadius = 10;
   impulseForce = 15;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.8 0.5 0";
   lightEndColor = "0 0 0";
};

