//-----------------------------------------------------------------------------
// Torque Game Engine
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================

//-----------------------------------------------------------------------------
// Misc. server commands available to clients
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
function serverCmdCommanderDropAmmo(%client, %position)
{
   // Create the projectile object
   %newpos  = getword(%position,0) SPC getword(%position,1) SPC (getword(%position,2) + 200) ;

   %crate = new Item() {
      dataBlock    = AmmoDrop;
      sourceObject = %client.player;
      client       = %client;
	   position     = %newpos;
	   teamID       = %client.team.teamID;
   };

   MissionCleanup.add(%crate);
   %crate.openChute();
   %crate.schedulePop();
   return %crate;
}
//-----------------------------------------------------------------------------
function serverCmdCommanderDropMedical(%client, %position)
{
   // Create the projectile object
   %newpos  = getword(%position,0) SPC getword(%position,1) SPC (getword(%position,2) + 200) ;

   %health = new Item() {
      dataBlock    = MedicDrop;
      sourceObject = %client.player;
      client       = %client;
	   position     = %newpos;
	   teamID       = %client.team.teamID;
   };
   MissionCleanup.add(%health);
   %health.openChute();
   %health.schedulePop();
   return %health;
}
//-----------------------------------------------------------------------------
function serverCmdCommanderDropWaypoint(%client, %position)
{
   %WayPoint = new WayPoint() {
      dataBlock        = WayPointMarker;
	  position = %position;
      team = %client.team.teamID;
   };
   MissionCleanup.add(%WayPoint);

}
//-----------------------------------------------------------------------------
function serverCmdCommanderDropTarget(%client, %position)
{
   %target = new Target() {
      dataBlock        = TargetMarker;
	  position = %position;
      team = %client.team.teamID;
   };
   MissionCleanup.add(%target);
}
//-----------------------------------------------------------------------------
function serverCmdGuiCommanderHudIconClick(%client, %ghostNdx)
  {
   %serverObj =  %client.ResolveGhost( %ghostNdx );
   if (%serverObj.getClassName() $= "SpawnSphere" && %client.team.teamID == %serverObj.getTeam())
     {
       %client.Spawner = %serverObj; //Set spawner choice

      //now spawn the guy here if he is not yet spawned
     commandToClient(%client, 'SpawnPointChosen' );
    }
}

// check and see if this client has already chosen a spawn point, and if so send a reply back
// if no spawn point, then do nothing
function serverCmdCheckAutoSpawn(%client)
  {
   if (!isObject(%client.spawner) ) return;

   // make sure spawn point owner has not changed
   if (%client.team.teamID == %client.spawner.getTeam())
     {
      commandToClient(%client, 'SpawnPointChosen');
     }
  }

function serverCmdToggleCamera(%client)
{
   %control = %client.getControlObject();
   if (%control == %client.player)
   {
      %control = %client.camera;
      %control.mode = toggleCameraFly;
   }
   else
   {
      %control = %client.player;
      %control.mode = observerFly;
   }
   %client.setControlObject(%control);
}

function serverCmdDropPlayerAtCamera(%client)
{
   if ($Server::TestCheats || isObject(EditorGui))
   {
      %client.player.setTransform(%client.camera.getTransform());
      %client.player.setVelocity("0 0 0");
      %client.setControlObject(%client.player);
   }
}

function serverCmdDropCameraAtPlayer(%client)
{
   %client.camera.setTransform(%client.player.getEyeTransform());
   %client.camera.setVelocity("0 0 0");
   %client.setControlObject(%client.camera);
}


//-----------------------------------------------------------------------------

function serverCmdSuicide(%client)
{
   if (isObject(%client.player))
      %client.player.kill("Suicide");
}

function serverCmdPlayCel(%client,%anim)
{
   if (isObject(%client.player))
      %client.player.playCelAnimation(%anim);
}

function serverCmdPlayDeath(%client)
{
   if (isObject(%client.player))
      %client.player.playDeathAnimation();
}
// Teamplay
function serverCmdJoinTeam(%client, %teamid)
{
   %client.joinTeam(%teamid);

}

// Teamplay - pick a class
function serverCmdJoinPlayerClass(%client, %classid)
{
    %client.joinPlayerClass(%classid);
}


function serverCmdWeaponReload(%client){
   %currentWeapon = %client.player.getMountedImage($WeaponSlot);
   %currentWeapon.ReloadAmmoClip(%client.player);
}

function serverCmdMountVehicle(%client)
{
   //Determine how far should the picking ray extend into the world?
   %selectRange = 10;

   // Only search for vehicles

   %pos = %client.player.getEyePoint();

   // Start with the shape's eye vector...
   %eye = %client.player.getEyeVector();
   %eye = vectorNormalize(%eye);
   %vec = vectorScale(%eye, %selectRange);

   %end = vectorAdd(%vec, %pos);

   // 1st look for something to mount and see how far away it is

   %searchMasks = $TypeMasks::vehicleObjectType | $TypeMasks::TurretObjectType;
   %scanTarg = ContainerRayCast (%pos, %end, %searchMasks);
   if (%scanTarg)
   {
     %x = getWord(%scanTarg, 1);
     %y = getWord(%scanTarg, 2);
     %z = getWord(%scanTarg, 3);
	 %contactPos = %x SPC %y SPC %z ;
   }
   else
   {
      echo("No object found");
	  return;
   }

   %mountObjectDistance = VectorDist(%pos,  %contactPos);

   // next check for any obstacles between us and the vehicle
   %searchMasks = $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::StaticTSObjectType;
   %scanTarg2 = ContainerRayCast (%pos, %end, %searchMasks);
   if (%scanTarg2)
   {
     %x = getWord(%scanTarg2, 1);
     %y = getWord(%scanTarg2, 2);
     %z = getWord(%scanTarg2, 3);
	 %contactPos = %x SPC %y SPC %z ;
	 %OtherObjectDistance = VectorDist(%pos,  %contactPos);
         if ( %OtherObjectDistance < %mountObjectDistance)
           {
            %obj = firstWord(%scanTarg2);
            echo("Can't mount, " @ %obj.getClassName() @ " is in the way");
	    return;
           }
   }

   // still here, ok, mount that first object
   %targetObject = firstWord(%scanTarg);
   onMountVehicle(%targetObject.getDataBlock(),
                     %client.player,
                     %targetObject);

}
////////////////////////////////////
// Engineering action, move as needed
////////////////////////////////////

function onRepairVehicle(%client, %vehicle)
{
   serverPlay3D(RepairVehicleSound,%vehicle.getTransform());
   %vehicle.applyRepair(50);
   // simple; we move, we lose the next raycheck.
   %client.player.repairingVehicle = schedule(1000, 0, "serverCmdRepairVehicle", %client);
}

function serverCmdRepairVehicle(%client)
{
   cancel(%client.player.repairingVehicle);

   // Engineers Only
   if (%client.playerClass != $PlayerClass3)
   {
      messageClient(%client, "Sorry, only engineers may attempt repairs.");
      return;
   }
   // Proper object(s)?
   if(%client.player.getMountedImage($WeaponSlot).item !$= "MonkeyWrench")
   {
      messageClient(%client, "Hey, you're not that good! You're going to need some tools for this job.");
      return;
   }
   // Uh.. Dead?
   if (%client.player.getState() $= "Dead")
      return;  // forget the message, surely they know they died!

   // Okay, let's find something to repairs

   //Distance setting, adjust to needs.
   %selectRange = 10;

   // What can we repair?
   %searchMasks = $TypeMasks::vehicleObjectType | $TypeMasks::TurretObjectType;

   // Start with the shape's eye vector...
   %pos = %client.player.getEyePoint();
   %eye = %client.player.getEyeVector();
   %eye = vectorNormalize(%eye);
   %vec = vectorScale(%eye, %selectRange);

   %end = vectorAdd(%vec, %pos);

   %scanTarg = ContainerRayCast (%pos, %end, %searchMasks);

   // a target in range was found so select it
   if (%scanTarg)
   {
      %targetObject = firstWord(%scanTarg);
      if(%targetObject.getDamageLevel() == 0)
      {
         messageClient(%client, "Everythings fine here. Move along.");
         return;
      }
      onRepairVehicle(%client, %targetObject);
   }
   else
   {
      messageClient(%client, "Everythings fine here. Move along.");
   }
}
/////////////////////////////////
// End engineers
//////////////////////////////
function serverCmdSetGravity(%client, %gravity)
{
   %client.player.mvehicle.setGravity(%gravity);
}

function serverCmdDismountVehicle(%client)
{
   doPlayerDismount(%client, %client.player, %true);

}

function serverCmdFindNextFreeSeat(%client)
{
   //Does the player even have a current vehicle?
   if(!isObject(%client.player.mvehicle))
      return;

   %newSeat = findNextFreeSeat(%client,
                               %client.player.mvehicle,
                               %client.player.mvehicle.getDataBlock());
   if (%newSeat != -1 && %newSeat !$= "Turret" && %newSeat !$= "Vehicle")
     {
      setActiveSeat(%client,
                    %client.player.mvehicle,
                    %client.player.mvehicle.getDataBlock(),
                    %newSeat);
   }
   else if (%newSeat $= "Vehicle")
   {
      %client.player.mvehicle = %client.player.mvehicle.getobjectmount();
      onMountVehicle(%client.player.mvehicle.getDataBlock(),
                     %client.player,
                     %client.player.mvehicle);
   }
   else if (%newSeat $= "Turret")
   {
      // Dream turrets
      %obj.mountedTurret = "";
      %vehicle = %client.player.mvehicle;
      %vehicle.mountedTurret.mountObject(%client.player,0);
      %vehicle.mountedTurret.currentDriver = %client;
      %vehicle.mountedTurret.getDataBlock().playerMounted(%vehicle,%client.player, %vehicle.mountedTurret.getDataBlock());

      setActiveSeat(%client.player,
                    %vehicle.mountedTurret,
                    %vehicle.mountedTurret.getDataBlock(),
                    0);
   }
   else
   {
      echo("No next free seat");
   }
}

// Heli Resource Code End //
//Starter.Combat
function serverCmdSetPlayerPos(%client,%pos)
 {
  if (isObject(%client.player))
    %client.player.setPlayerPosition(%pos);
 }

function serverCmdGetPlayerPos(%client)
  {
   if (isObject(%client.player))
     return %client.player.getPosition();
   else
     return 0;
  }
