// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================
datablock AudioProfile(Computer)
{
filename = "~/data/sound/combat/computer.ogg";
description = AudioKCloseLooping3d;
preload = true;
};

datablock AudioProfile(ComputerOff)
{
filename = "~/data/sound/combat/comoff.ogg";
description = AudioKCloseLooping3d;
preload = true;
};

datablock StaticShapeData(Panel)
{
   category = "Animated Shapes";
   className = DefaultPanelData;
   shapeFile = "~/data/shapes/combat/panel.dts";

   maxDamage     = 24000; // destroyed at 1000
   disabledLevel = 23000; // disabled beyond this damage
   destroyedLevel = 23900;
   minCollisionSpeed = 1000; // help prevent wierd collision errors
   explosion       = VehicleExplosion;
};

function Panel::onAdd(%this,%obj)
{
   %obj.playthread(0,"panel");
   %obj.playAudio(0,Computer);
}

function Panel::onDamage(%this,%obj,%amount)
  {
   %damageAmt = %obj.getDamageLevel();

   if (%damageAmt >= %this.destroyedLevel)
     {
      %obj.setDamageState(destroyed);
     }

   // if we get here and amage is zero, then the radar has been repaired
   if (%damageAmt == 0)
     {
      %obj.setDamageState(Enabled);
      %this.onEnable(%obj);
     }
}

function Panel::onEnable(%this, %obj)
  {
   %count = ClientGroup.getCount();
   for (%cl = 0; %cl < %count; %cl++)
	{
      %client = ClientGroup.getObject(%cl);
          if (%client.team.TeamID == %obj.teamID)
            commandToClient(%client, 'panelStatus', 'on');

    }
   %obj.playAudio(0,Computer);
  }

function Panel::damage(%this, %obj, %projectile, %pos, %damage, %damageType)
  {
   if (%obj.getDamageLevel() >= %this.destroyedLevel)
     {
      return;
     }
   echo(%obj.getName() @ " takes " @ %damage @ " damage from " @ %projectile.client.nameBase @ " type: "@ %damageType @ " dmgLevel: " @ %obj.getDamageLevel() );

   if (%obj.teamID == %projectile.client.team.teamID)
     return; // anti-greifer check

   // check to see if damage bounces off
   if (%this.armorvalue >= %damage) return;

   // subtract armor value from incomming damage & apply the result
   %value = %damage - %this.armorValue;
   %obj.applyDamage(%value);

   // if last damage value set panel to a destroyed state, record that.
   if (%obj.getDamageLevel() >= %this.destroyedLevel)
     {
      $TManager.recordAction(%projectile.client, "PanelDestroyed", %obj);
     }
  }

function Panel::onDestroyed(%data, %obj, %prevState)
  {
   %obj.schedule(1000, "delete");

   // spawn destroyed control panel
   new TSStatic() {
      position = %obj.position;
      rotation = %obj.rotation;
      shapeName = "~/data/shapes/combat/destpanel.dts";
   };

  }

