// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================

datablock AudioProfile(ArtExplosionSound)
{
filename = "~/data/sound/combat/exp3.ogg";
description = AudioClose3d;
preload = true;
};

datablock AudioProfile(TurretGunFireSound)
{
filename = "~/data/sound/combat/Rifle1.ogg";
description = AudioClose3d;
preload = true;
};

datablock DebrisData(TurretDebris)
{
	explodeOnMaxBounce = false;

	elasticity = 0.15;
	friction = 0.5;

	lifetime = 2.0;
	lifetimeVariance = 0.0;

	minSpinSpeed = 40;
	maxSpinSpeed = 60;

	numBounces = 5;
	bounceVariance = 0;

	staticOnMaxBounce = true;
	gravModifier = 1.0;

	useRadiusMass = true;
	baseRadius = 1;

	velocity = 30.0;
	velocityVariance = 12.0;
};

datablock ItemData(TurretAmmo) //Duncan - I put this here temporary because someone deleted the original
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "~/data/shapes/crossbow/ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   // Dynamic properties defined by the scripts
   pickUpName = "Turret Ammo";
   maxInventory = 300;
};

datablock TurretData(GenericTurret)
  {
   category                 = "Turrets";
   numPoints                = 100;

   shapeFile                = "~/data/shapes/turrets/50cal.dts";
   maxDamage                = 110;
   explosion                = TurretExplosion;
   destroyedLevel           = 110;
   disabledLevel            = 0.84;
   debrisShapeName          = "~/data/shapes/turrets/50cal.dts";
   debris                   = TurretDebris;
   renderWhenDestroyed      = false;
   mountPose[0]             = root;
   numMountPoints           = 1;
   MountPoint               = 0;
   isProtectedMountPoint[0] = true;
   cameraMaxDist            = 20;
   cameraOffset             = 4.5;
   maxEnergy                = 280;
   rechargeRate             = 0.2;
   heat                     = 1.0;


   maxPitchSpeed = 180.0; // barrel up/down degrees/second
   maxYawSpeed   = 180.0;   // rotate degrees/second
   minPitch      = -40; // up angle
   maxPitch      = 45; // down angle
   minYaw        = -80;   // we speak of the constraints on yaw as if it's range
   maxYaw        = 80;    // were -180/180 even tho it's actually stored as 0..360

   // mounted by default in TurretData if specified
   barrelSlot               = 0;
   barrel                   = SmallTurretGun;

   // crosshair hud image to display when a player controls this turret from a vehicle
   crosshair = "none";
   maxInv[TurretAmmo] = TurretAmmo.maxInventory;
  };

datablock TurretData(GenericAutoTurret:GenericTurret)
{
   //This turret is designed for automatic fire and uses a different image rather than a single shot image
   barrelSlot               = 0;
   barrel                   = SmallAutoTurretGun;

};

datablock ProjectileData(TurretProjectile)
{
   projectileShapeName = "~/data/shapes/Rifle/projectile.dts";
   directDamage        = 80;
   radiusDamage        = 30;
   damageRadius        = 10;
   areaImpulse         = 100;

   explosion           = BulletDebrisExplosion;
   splash              = BulletSplash;
   linetracer          = BulletTracer;

   decals[0] = RifleBulletDecal;

   muzzleVelocity      = 1500;
   velInheritFactor    = 0.3;

   armingDelay         = 0;
   lifetime            = 3000;
   fadeDelay           = 1500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
};

datablock ShapeBaseImageData(smallAutoTurretGun)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/turrets/turretBarrel.dts";
   mass = 15;
   //category					= "Turrets";  // you dont want to place these

   mountPoint = 0;
   offset = "0 0 0";
   casing = RifleShell;
   ammo = TurretAmmo;
   item = RocketLauncher;
   projectile = TurretProjectile;
   projectileType = Projectile;
   correctMuzzleVector = false;   // do not fire at what the cam node looks at

   // I dont implement use of these in script
   // but old turret stuff had this...
   usesEnergy = false;
   fireEnergy = 10;
   minEnergy = 4;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the AssaultRifle is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 1.0;
   stateSequence[1]                 = "Activate";

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   // Fire the AssaultRifle. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Ready";
   stateTimeoutValue[3]             = 0.05;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateEmitter[3]                  = RifleFireEmitter;
   stateEmitterTime[3]              = 0.07;
   stateSound[3]                    = TurretGunFireSound;

   // Play the reload animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.05;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;
   stateScript[4]                   = "onReload";
   stateSound[4]                    = RifleReloadSound;

   // No ammo in the AssaultRifle, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "onReload";
   stateTransitionOnTriggerDown[5]  = "DryFire";
   stateSound[5]                    = RifleFireEmptySound;

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 0.05;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(smallTurretGun)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/turrets/turretBarrel.dts";
   mass = 15;
   //category					= "Turrets";  // you dont want to place these

   mountPoint = 0;
   offset = "0 0 0";
   casing = RifleShell;
   ammo = TurretAmmo;
   item = RocketLauncher;
   projectile = TurretProjectile;
   projectileType = Projectile;
   correctMuzzleVector = false;   // do not fire at what the cam node looks at

   // I dont implement use of these in script
   // but old turret stuff had this...
   usesEnergy = false;
   fireEnergy = 10;
   minEnergy = 4;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the AssaultRifle is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 1.0;
   stateSequence[1]                 = "Activate";

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   // Fire the AssaultRifle. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.05;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateEmitter[3]                  = RifleFireEmitter;
   stateEmitterTime[3]              = 0.07;
   stateSound[3]                    = TurretGunFireSound;

   // Play the reload animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.05;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;
   stateScript[4]                   = "onReload";
   stateSound[4]                    = RifleReloadSound;

   // No ammo in the AssaultRifle, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "onReload";
   stateTransitionOnTriggerDown[5]  = "DryFire";
   stateSound[5]                    = RifleFireEmptySound;

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 0.05;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};



function GenericTurret::onAdd(%this,%obj)
{
   // if you do not specify a barrel then you
   // need to do this...
   %turretSlot = 1;
   %obj.setEnergyLevel(%this.MaxEnergy);
   %obj.getMountedImage(%turretSlot);
   %obj.mountImage(SmallTurretGun,%turretSlot);
   %obj.setInventory(TurretAmmo, TurretAmmo.maxInventory);
}

function GenericAutoTurret::onAdd(%this,%obj)
{
   // if you do not specify a barrel then you
   // need to do this...
   %turretSlot = 1;
   %obj.setEnergyLevel(%this.MaxEnergy);
   %obj.getMountedImage(%turretSlot);
   %obj.mountImage(SmallAutoTurretGun,%turretSlot);
   %obj.setInventory(TurretAmmo, TurretAmmo.maxInventory);
}

function smallTurretGun::onFire(%this, %obj, %slot)
  {
   return fireProjectile(%this, %obj, %slot);
  }

function smallTurretGun::ReloadAmmoClip(%this, %obj)
  {

  }

function smallAutoTurretGun::onFire(%this, %obj, %slot)
{
   return fireProjectile(%this, %obj, %slot);
}

function smallAutoTurretGun::ReloadAmmoClip(%this, %obj)
{

}

function Turret::onAdd(%this,%obj)
{
 // here to prevent console spam
}


function TurretProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   if (%col == %obj.client.player) return;

   // Apply damage to the object all shape base objects
   if (%col.getType() & $TypeMasks::ShapeBaseObjectType)
      %col.damage(%obj,%pos,%this.directDamage, %this.getName() );
}
