// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================


//-----------------------------------------------------------------------------
datablock AudioDescription(HeliLooping3d)
{
   volume            = 1.0;
   isLooping         = true;
   loopCount         = 5;
   is3D              = true;
   ReferenceDistance = 25.0;
   MaxDistance       = 100.0;
   type              = $SimAudioType;
};

datablock AudioProfile(heliEngineSound)
{
   filename    = "~/data/shapes/heli/heli.ogg";
   description = HeliLooping3d;
   preload     = true;
};

datablock AudioProfile(heliExplosionSound)
{
filename    = "~/data/sound/combat/exp3.ogg";
description = AudioDefault3d;
preload     = true;
};

datablock AudioProfile(HeliLiteImpactSound)
{
filename    = "~/data/sound/combat/m_crunch.ogg";
description = AudioClose3d;
preload     = true;
};

datablock AudioProfile(HeliImpactSound)
{
filename    = "~/data/sound/combat/crash.ogg";
description = AudioClose3d;
preload     = true;
};

datablock ParticleData(HeliDustParticle)
{
   textureName          = "~/data/shapes/particles/smoke";
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 0;
   useInvAlpha =  true;
   colors[0]            = "0.46 0.46 0.46 1.0";
   colors[1]            = "0.16 0.16 0.16 0.0";
   sizes[0]             = 5.50;
   sizes[1]             = 5.0;
};

datablock ParticleEmitterData(HeliDustEmittera)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 6;
   velocityVariance = 3.0;
   ejectionOffset   = 0.0;
   thetaMin         = 5;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles        = "HeliDustParticle";
};
datablock ParticleEmitterData(HeliDustEmitterb)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 6;
   velocityVariance = 3.0;
   ejectionOffset   = 0.0;
   thetaMin         = 5;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles        = "HeliDustParticle";
};
datablock ParticleEmitterData(HeliDustEmitterc)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 6;
   velocityVariance = 3.0;
   ejectionOffset   = 0.0;
   thetaMin         = 5;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles        = "HeliDustParticle";
};

datablock ParticleData(LightDamageParticle1)
{
   textureName          = "~/data/shapes/particles/smoke";
   dragCoefficient     = 0.0;
   gravityCoefficient   = -0.3;   // rises slowly
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 250;
   useInvAlpha = true;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.6 0.6 0.0 0.1";
   colors[1]     = "0.8 0.6 0.0 0.1";
   colors[2]     = "0.0 0.0 0.0 0.1";

   sizes[0]      = 0.8;
   sizes[1]      = 1.9;
   sizes[2]      = 3.4;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleData(LightDamageParticle2)
{
   textureName          = "~/data/shapes/particles/smoke";
   dragCoefficient     = 0.0;
   gravityCoefficient   = -0.5;   // rises slowly
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 150;
   useInvAlpha = true;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.8 0.6 0.0 0.1";
   colors[1]     = "0.6 0.6 0.0 0.1";
   colors[2]     = "0.0 0.0 0.0 0.1";

   sizes[0]      = 1.3;
   sizes[1]      = 1.3;
   sizes[2]      = 1.3;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(LightDamageEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 5;

   ejectionVelocity = 0.25;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 45.0;

   particles = "LightDamageParticle1" TAB "LightDamageParticle2";
};

datablock ParticleData(HeavyDamageParticle)
{
   textureName          = "~/data/shapes/particles/smoke";
   dragCoefficient      = 0.0;
   windCoefficient      = 0.0;
   gravityCoefficient   = -0.05;   // rises slowly
   inheritedVelFactor   = 0.00;
   lifetimeMS           = 5000;
   lifetimeVarianceMS   = 1000;
   useInvAlpha = true;
   spinRandomMin = -90.0;
   spinRandomMax = 90.0;
   spinSpeed = 1.0;

   colors[0]     = "0.2 0.2 0.0 0.2";
   colors[1]     = "0.6 0.2 0.0 0.2";
   colors[2]     = "0.4 0.0 0.0 0.1";
   colors[3]     = "0.1 0.04 0.0 0.3";

   sizes[0]      = 1.5;
   sizes[1]      = 6.0;
   sizes[2]      = 7.0;
   sizes[3]      = 9.0;

   times[0]      = 0.0;
   times[1]      = 0.1;
   times[2]      = 0.2;
   times[3]      = 0.3;
};

datablock ParticleEmitterData(HeavyDamageEmitter)
{
   ejectionPeriodMS = 50;
   periodVarianceMS = 0;

   ejectionVelocity = 0.55;
   velocityVariance = 0.00;
   ejectionOffset = 1.0;


   thetaMin         = 1.0;
   thetaMax         = 100.0;

   particles = "HeavyDamageParticle";
};

datablock ParticleData(DefaultHeliExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.5;
   inheritedVelFactor   = 0.9;
   constantAcceleration = 0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 200;
   useInvAlpha =  false;
   textureName          = "~/data/shapes/particles/smoke";
   colors[0]            = "0.86 0.36 0.26 1.0";
   colors[1]            = "0.70 0.36 0.26 0.5";
   colors[2]            = "0.56 0.36 0.26 0.0";
   sizes[0]             = 8.5;
   sizes[1]             = 11.5;
   sizes[2]             = 17.0;
};

datablock ParticleEmitterData(DestroyedEmitter)
{
   ejectionPeriodMS = 50;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 3.0;
   ejectionOffset   = 0.4;
   thetaMin         = 5;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles        = "defaultHeliExplosionParticle";
};

datablock DebrisData(defaultHeliDebri)
{
   explodeOnMaxBounce = false;

   elasticity         = 0.15;
   friction           = 0.5;

   lifetime           = 1000;
   lifetimeVariance   = 0.0;

   minSpinSpeed       = 40;
   maxSpinSpeed       = 600;

   numBounces         = 6;
   bounceVariance     = 2.3;

   staticOnMaxBounce  = true;
   gravModifier       = 1.0;

   useRadiusMass      = true;
   baseRadius         = 1;

   velocity           = 20.0;
   velocityVariance   = 12.0;
};

//-----------------------------------------------------------------------------
// Explosion Debris

// Debris "spark" explosion
datablock ParticleData(heliDebrisSpark)
{
   textureName          = "~/data/shapes/particles/fire";
   dragCoefficient      = 0;
   gravityCoefficient   = 0.0;
   windCoefficient      = 0;
   inheritedVelFactor   = 0.5;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 50;
   spinRandomMin        = -90.0;
   spinRandomMax        =  90.0;
   useInvAlpha          = false;

   colors[0]            = "0.8 0.2 0 1.0";
   colors[1]            = "0.8 0.2 0 1.0";
   colors[2]            = "0 0 0 0.0";

   sizes[0]             = 0.2;
   sizes[1]             = 0.3;
   sizes[2]             = 0.1;

   times[0]             = 0.0;
   times[1]             = 0.5;
   times[2]             = 1.0;
};

datablock ParticleEmitterData(heliDebrisSparkEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   velocityVariance = 0.25;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 300;
   particles        = "heliDebrisSpark";
};

datablock ExplosionData(heliDebrisExplosion)
{
   emitter[0]       = heliDebrisSparkEmitter;

   // Turned off..
   shakeCamera      = false;
   impulseRadius    = 0;
   lightStartRadius = 0;
   lightEndRadius   = 0;
};

// Debris smoke trail
datablock ParticleData(heliDebrisTrail)
{
   textureName          = "~/data/shapes/particles/fire";
   dragCoefficient      = 1;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   windCoefficient      = 0;
   constantAcceleration = 0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 100;
   spinSpeed            = 0;
   spinRandomMin        = -90.0;
   spinRandomMax        =  90.0;
   useInvAlpha          = true;

   colors[0]            = "0.8 0.3 0.0 1.0";
   colors[1]            = "0.1 0.1 0.1 0.7";
   colors[2]            = "0.1 0.1 0.1 0.0";

   sizes[0]             = 0.2;
   sizes[1]             = 0.3;
   sizes[2]             = 0.4;

   times[0]             = 0.1;
   times[1]             = 0.2;
   times[2]             = 1.0;
};

datablock ParticleEmitterData(heliDebrisTrailEmitter)
{
   particles        = "heliDebrisTrail";

   ejectionPeriodMS = 10;
   periodVarianceMS = 5;

   ejectionVelocity = 0.25;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 90.0;
};

// Debris object
datablock DebrisData(heliExplosionDebris)
{
   emitters           = heliDebrisTrailEmitter;
   explosion          = heliDebrisExplosion;

   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 8.0;
   lifetimeVariance = 4.0;

   minSpinSpeed = 5;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = false;
   snapOnMaxBounce = true;
   gravModifier = 2.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 30.0;
   velocityVariance = 12.0;

};

datablock ParticleData(heliExplosionSmoke)
{
   textureName          = "~/data/shapes/particles/smoke";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = -0.30;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 300;
   useInvAlpha          =  true;
   spinRandomMin        = -80.0;
   spinRandomMax        =  80.0;

   colors[0]            = "0.56 0.36 0.26 1.0";
   colors[1]            = "0.2 0.2 0.2 1.0";
   colors[2]            = "0.0 0.0 0.0 0.0";

   sizes[0]             = 4.0;
   sizes[1]             = 5;
   sizes[2]             = 6;

   times[0]             = 0.0;
   times[1]             = 0.5;
   times[2]             = 1.0;
};

datablock ParticleEmitterData(heliExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 1250;
   particles        = "heliExplosionSmoke";
};

datablock ParticleData(heliExplosionFire)
{
   textureName          = "~/data/shapes/particles/fire";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = 0.1;
   lifetimeMS           = 5200;
   lifetimeVarianceMS   = 300;
   useInvAlpha          =  false;
   spinRandomMin        = -80.0;
   spinRandomMax        =  80.0;

   colors[0]            = "0.8 0.4 0 0.8";
   colors[1]            = "0.2 0.0 0 0.8";
   colors[2]            = "0.0 0.0 0.0 0.0";

   sizes[0]             = 1.5;
   sizes[1]             = 3;
   sizes[2]             = 5;

   times[0]             = 0.0;
   times[1]             = 0.5;
   times[2]             = 1.0;
};

datablock ParticleEmitterData(heliExplosionFireEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.8;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles        = "heliExplosionFire";
};

datablock ParticleData(heliExplosionSparks)
{
   textureName          = "~/data/shapes/particles/spark";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;

   colors[0]            = "0.60 0.40 0.30 1.0";
   colors[1]            = "0.60 0.40 0.30 1.0";
   colors[2]            = "1.0 0.40 0.30 0.0";

   sizes[0]             = 0.25;
   sizes[1]             = 0.15;
   sizes[2]             = 0.15;

   times[0]             = 0.0;
   times[1]             = 0.5;
   times[2]             = 1.0;
};

datablock ParticleEmitterData(heliExplosionSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles        = "heliExplosionSparks";
};

datablock ExplosionData(heliSubExplosion1)
{
   offset     = 0;
   emitter[0] = heliExplosionSmokeEmitter;
   emitter[1] = heliExplosionSparkEmitter;
};

datablock ExplosionData(heliSubExplosion2)
{
   offset     = 1.0;
   emitter[0] = heliExplosionSmokeEmitter;
   emitter[1] = heliExplosionSparkEmitter;
};

datablock ExplosionData(heliExplosion)
{
   soundProfile           = heliExplosionSound;
   lifeTimeMS             = 1200;

   // Volume particles
   particleEmitter        = heliExplosionFireEmitter;
   particleDensity        = 300;
   particleRadius         = 8;

   // Point emission
   emitter[0]             = heliExplosionSmokeEmitter;
   emitter[1]             = heliExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0]        = heliSubExplosion1;
   subExplosion[1]        = heliSubExplosion2;

   // Camera Shaking
   shakeCamera            = true;
   camShakeFreq           = "10.0 11.0 10.0";
   camShakeAmp            = "1.0 1.0 1.0";
   camShakeDuration       = 0.5;
   camShakeRadius         = 10.0;

   // Exploding debris
   debris = heliExplosionDebris;
   debrisThetaMin         = 0;
   debrisThetaMax         = 60;
   debrisPhiMin           = 0;
   debrisPhiMax           = 360;
   debrisNum              = 7;
   debrisNumVariance      = 5;
   debrisVelocity         = 0.8;
   debrisVelocityVariance = 0.4;

   // Impulse
   impulseRadius          = 20;
   impulseForce           = 40;

   // Dynamic light
   lightStartRadius       = 6;
   lightEndRadius         = 3;
   lightStartColor        = "0.5 0.5 0";
   lightEndColor          = "0 0 0";
};

//-----------------------------------------------------------------------------
datablock HeliVehicleData(HeliVehicleBase)
{
   vehicleType = "helicopter";
   category    = "Vehicles";
   emap        = true;
   shapeFile   = "~/data/shapes/heli/helicopter1.dts";

   // Mounting
   mountable     = true;           // Usable or not
   maxMountSpeed = 100.0;          // ms time to mount, this should match any animation used
   mountDelay    = 0;              // wait a sec first?
   dismountDelay = 10.5;           // no jumping in and out faster than we can keep track of it

   stationaryThreshold = 0.5;
   maxDismountSpeed    = 100.0;    // ms time dismount, this should match any animation used

   maxDamage      = 4000.0;      // Used by emitters. Basically, you could think of it as engine damage
   destroyedLevel = 4000.0;      // Used on the object itself, this will call onDestroyed() etc. Hull explosions, client-side

   // 3rd person camera settings
   cameraRoll = false;           // Roll the camera with the vehicle
   cameraMaxDist = 23;           // Far distance from vehicle
   cameraOffset = 9;             // Vertical offset from camera mount point
   cameraLag = 0.9;              // Velocity lag of camera
   cameraDecay = 0.75;           // Decay per sec. rate of velocity lag

   isShielded = false;

   maxEnergy = 250;               //Afterburner and any energy weapon pool. Gasoline.
   rechargeRate = 0;              //Solar batteries recharging our engines automatically?

   maxAutoSpeed = 5;              //Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 20000;      //Angular stabilizer force (this force levels you out when autostabilizer kicks in) up & down force
   autoLinearForce = 20000;       //Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;       //Dampen control input so you don't` whack out at very slow speeds
   manueverAltitude = 5;          //Below this altitude (measured off terrain), you have limited maneuvering ability

   // Maneuvering
   maneuveringForce = 1500;       //Horizontal jets (W,S,D,A key thrust)
   maxSteeringAngle = 0.610;      //35 degree max rotations
   minDrag = 2000;                //Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 55;           //Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   horizontalSurfaceForce = 8000; //Horizontal center "wing" (provides "bite" into the wind for climbing/diving & turning)
   verticalSurfaceForce = 1000;   //Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   steeringForce = 90000;         //Steering jets (force applied when you move the mouse)
   steeringRollForce = 75;        //Steering jets (how much you heel over when you turn)
   rollForce = 40000;             //Auto-roll (self-correction to right you after you roll/invert)
   flyingHeight = 18.8;           //Height off the ground at rest
   pitchLinForce = 10.0;

   // Turbo Jet
   jetForce = 5000;               //Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 0.0;            //Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 5;            //Energy use of the afterburners (low number is less drain...can be fractional)
   vertThrustMultiple = 1;        //Higher number means going up and down faster

   // Rigid body
   mass = 5940;                   //Mass of the vehicle
   bodyFriction = 0.5;            //Slide on ground, after an impact or such (at least for flying)
   bodyRestitution = 0.4;         //When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 100;            //Don't mess with this.
   softImpactSpeed = 5;           //Sound hooks. This is the soft hit.
   hardImpactSpeed = 10;          //Sound hooks. This is the hard hit.
   integration = 4;               // Physics integration: TickSec/Rate
   collisionTol = 1;              // Collision distance tolerance
   contactTol = 0.1;              // Contact velocity tolerance

   // Impact Damage
   minImpactSpeed = 11.552;       //If hit ground at speed above this then it's an impact, calling all scripts! Meters/second (32/ft second currently used)
   softImpactSpeed = 5;           // soft hit, calls sound
   hardImpactSpeed = 10;          // harder hit, calls sound

   // Sounds
   engineSound             = HeliEngineSound;
   softImpactSound         = HeliLiteImpactSound;
   hardImpactSound         = HeliImpactSound;

   damageEmitter[0]        = LightDamageEmitter;
   damageEmitter[1]        = HeavyDamageEmitter;
   damageEmitter[2]        = DestroyedEmitter;
   damageEmitterOffset[0]  = "0.0 -3.0 5 ";
   damageEmitterOffset[1]  = "0.0 0.0 5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas      = 1;
   dustEmitter[0]          = HeliDustEmittera;
   dustEmitter[1]          = HeliDustEmitterb;
   dustEmitter[2]          = HeliDustEmitterc;
   dustEmitterOffset[0]    = "50.0 -3.0 -10.0 ";
   dustEmitterOffset[1]    = "1.0 70.0 -10.0 ";
   dustEmitterOffset[2]    = "0.0 0.0 -10.0 ";
   triggerDustHeight       = 10;
   //dustHeight = 0;

   // Explosion
   directDamage = 1000;
   damageRadius = 25;
   radiusDamage = 200;
   areaImpulse = 100;
   explosion       = heliExplosion;
   debrisShapeName = "~/data/shapes/heli/helicopterDebris.dts";
   debris          = heliExplosionDebris;

   speedDamageScale = 15;
   minCollisionSpeed = 5; // any collision above this value does damage to us
   maxImpactSpeed = 25;   // if hit the grounda above this speed, the heli is destroyed.
   armorValue = 5;        // damage must be above this amount to have any effect.
   EnglishName = "Helicopter";
   RespawnTimer = 60;     // 60 second respawn timer

   steeringDecay = 0.95;   // Scale the steering by this amount every tick, effective moves the steering to zero
   collisionMass = 122; // 12,200lbs courtesy of google
};


//-----------------------------------------------------------------------------
function HeliVehicleData::create(%block)
{
   %obj = new heliVehicle(){
      dataBlock = %block;
   };

   return(%obj);
}

function HeliVehicleData::onAdd(%this,%obj)
{
   %obj.setGravity(-20);
   %obj.defaultCam = $eyeView; // see top of vehicle.cs
   %obj.mountable = true;

   %obj.setEnergyLevel(%this.MaxEnergy);
   %obj.setRechargeRate(%this.rechargeRate);
   %obj.SpawnPos = %obj.position;
   %obj.SpawnRot = %obj.rotation;
}

// default callback from the engine
// deferr to generic impact function
function HeliVehicleData::onImpact(%this, %obj, %collide, %vec, %vecLen)
 {
  doVehicleImpact(%this, %obj, %collide, %vec, %vecLen);
 }

// Heli has been destroyed, delete carcas, and schedule a respawn
function HeliVehicleData::onDestroyed(%data, %obj, %prevState)
{
  %obj.stopThread(0);
  %obj.setEngineState(false);

  %obj.schedule($Vehicle::CorpseTimeout, "delete");
  %db = %obj.getDataBlock();
  %pos = %obj.SpawnPos;
  %rot = %obj.SpawnRot;
  if (%db.RespawnTimer)
     Schedule( (%db.RespawnTimer * 1000) + $Vehicle::CorpseTimeout, MissionGroup, "RespawnVehicle", "HeliVehicle", %db.getName() , %pos, %rot);
}


// send the initial ammo settings to %client
function HeliVehicle::initialAmmo(%this, %client)
{
   %datablock = %client.player.mVehicle.getDataBlock();
   %datablockName = %datablock.getName();

  if(%datablockName $= "DefaultHeli")
     DefaultHeli::initialAmmo(%this, %client);
  else
  if(%datablockName $= "TransHeli")
     TransHeli::initialAmmo(%this, %client);
}

// Vehicle specifics upon entering. We always pop other mappings, as this function will be called upon changing
// seats, as well as upon initial entering.
function HeliVehicle::onEnterVehicle(%this, %client, %seat)
{
   %datablockName = %client.player.mVehicle.getDataBlock().getName();

  if(%datablockName $= "DefaultHeli")
     DefaultHeli::onEnterVehicle(%this,%client, %seat);
  else
  if(%datablockName $= "TransHeli")
     TransHeli::onEnterVehicle(%this,%client, %seat);

}

function HeliVehicle::onExitVehicle(%this, %client)
{
   %datablockName = %client.player.mVehicle.getDataBlock().getName();

  if(%datablockName $= "DefaultHeli")
     DefaultHeli::onExitVehicle(%client, %seat);
  else
  if(%datablockName $= "TransHeli")
     TransHeli::onExitVehicle(%client, %seat);

}
