// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================
//Medic Drop

//------------------------------------------------------------------------------


//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.
datablock ItemData(MedicDrop)
{
   // Mission editor category
   category = "Weapon";

   // Hook into Item Weapon class hierarchy. The weapon namespace
   // provides common weapon handling functions in addition to hooks
   // into the inventory system.
   className = "Weapon";

   // Basic Item properties
   shapeFile = "~/data/shapes/combat/medbox.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

   // Dynamic properties defined by the scripts
   pickUpName = "a Medic Drop";
   iconType = $MediIcon;
   throwable="1";
};


function MedicDrop::onAdd(%this,%obj)
  {
   %obj.repairAmount = 20;
   %obj.maxRepairAmount = 300;
   %obj.currentRepairAmount = 0;
   schedule(3000,0,"DropHeal",%obj);
  }

function DropHeal(%obj)
{
   %position = %obj.getTransform();
   InitContainerRadiusSearch(%position, 1, $TypeMasks::PlayerObjectType);
   while ((%targetObject = containerSearchNext()) != 0)
   {
      if (%targetObject.getDamageLevel() != 0 && %targetObject.getState() !$= "Dead" && %targetObject.client.team.teamID $= %obj.teamID)
      {
         %targetObject.applyRepair(%obj.repairAmount);
         serverPlay3D(HealthUseSound,%obj.getTransform());
         %obj.currentRepairAmount += %obj.repairAmount;
      }
   }

   if(%obj.currentRepairAmount >= %obj.maxRepairAmount)
      %obj.delete();
   else
      schedule(3000, 0, "DropHeal",%obj);
}


function MedicDrop::onChuteOpen(%this, %obj)
{
  %obj.onChuteOpen();
}

function MedicDrop::onChuteClose(%this, %obj)
{
  %obj.onChuteClose();
}
