// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================
//Rifle
//-----------------------------------------------------------------------------
// Sounds profiles

datablock AudioProfile(PistolReloadSound)
{
filename = "~/data/sound/combat/LockNLoad2.ogg";
description = AudioClose3d;
preload = true;
};

datablock AudioProfile(PistolFireSound)
{
filename = "~/data/sound/combat/rifle2.ogg";
description = AudioClose3d;
preload = true;
};

datablock AudioProfile(PistolFireEmptySound)
{
filename = "~/data/sound/mp5_firing_empty.ogg";
description = AudioClose3d;
preload = true;
};

datablock AudioProfile(PistolExplosionSound)
{
filename = "~/data/sound/combat/explode.ogg";
description = AudioDefault3d;
preload = true;
};

datablock DecalData(PistolBulletDecal){
  sizeX       = 0.05;
   sizeY       = 0.05;
   Lifespan = 10000; // 10 seconds
   textureName = "~/data/shapes/rifle/textures/bullethole1";
};

//-----------------------------------------------------------------------------
// Projectile trail emitter
datablock ParticleData(PistolSmokeParticle)
{
   textureName          = "~/data/shapes/Rifle/smokeParticle";

   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.2;  // rises
   inheritedVelFactor   = 0.00;

   lifetimeMS           = 300;   // time in ms
   lifetimeVarianceMS   = 150;   // ...more or less

   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "0 0 0 0";

   sizes[0]      = 0.1;
   sizes[1]      = 0.15;
   sizes[2]      = 0.3;

   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(PistolSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 5;

   ejectionVelocity = 0.25;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   particles = PistolSmokeParticle;
};


//-----------------------------------------------------------------------------
//  fire emitter

datablock ParticleData(PistolFireParticle)
{
   textureName          = "~/data/shapes/Rifle/smokeParticle";

   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.1;  // rises
   inheritedVelFactor   = 0.3;

   lifetimeMS           = 300;   // Time in ms
   lifetimeVarianceMS   = 50;    // ...more or less

   useInvAlpha = false;
   spinRandomMin = -30.0;
   spinRandomMax = 30.0;

   colors[0]     = "1.0 1.0 1.0 0.0";
   colors[1]     = "0.56 0.36 0.26 1.0";
   colors[2]     = "0 0 0 0";

   sizes[0]      = 0.2;
   sizes[1]      = 0.5;
   sizes[2]      = 1;

   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(PistolFireEmitter)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 5;

   ejectionVelocity = 2;
   ejectionOffset   = 0.1;
   velocityVariance = 0.10;

   thetaMin         = 0.0;
   thetaMax         = 10.0;

   particles = PistolFireParticle;
};


datablock ProjectileData(PistolProjectile)
{
   projectileShapeName = "~/data/shapes/Rifle/projectile.dts";
   directDamage        = 15;

   explosion           = BulletDebrisExplosion;
   splash              = BulletSplash;
   linetracer          = BulletTracer;

   muzzleVelocity      = 1000;
   velInheritFactor    = 1;

   armingDelay         = 0.3;
   lifetime            = 150;
   fadeDelay           = 1500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;

   decals[0] = RifleBulletDecal;

};

function PistolProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   // Apply damage to the object all shape base objects
   %modifier = 1;
   if (%col.getType() & $TypeMasks::ShapeBaseObjectType)
   {
     %damLocWords = %col.getDamageLocation(%pos);
     %damLoc = firstWord(%damLocWords);

     if(%damLoc $= "head")
     {
        %modifier = 2;
        commandToClient(%obj.client, 'DisplayHeadHitGUI');
     }
     if(%damLoc $= "torso")
     {
        %modifier = 1;
        commandToClient(%obj.client, 'DisplayHitGUI');
     }
     if(%damLoc $= "legs")
     {
        %modifier = 0.5;
        commandToClient(%obj.client, 'DisplayHitGUI');
     }
     %col.damage(%obj, %pos ,%modifier * %this.directDamage,%this.getName(),%damLoc);
   }
}


//-----------------------------------------------------------------------------
// Ammo Item

datablock ItemData(PistolAmmo)
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "~/data/shapes/Rifle/Rifle_Clip.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   // Dynamic properties defined by the scripts
   pickUpName = "Pistol ammo";
   maxInventory = 18;
};

datablock ItemData(PistolAmmoClip)
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "~/data/shapes/Rifle/Rifle_Clip.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   // Dynamic properties defined by the scripts
   pickUpName = "a Pistol clip.";
   maxInventory = 6;

};

//--------------------------------------------------------------------------
//  shell that's ejected during reload.

datablock DebrisData(PistolShell)
{
   shapeFile = "~/data/shapes/Rifle/shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 5;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
};


//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.  When the Weapon
// is mounted onto a shape, the WeaponImage is used.

datablock ItemData(Pistol)
{
   // Mission editor category
   category = "Weapon";

   // Hook into Item Weapon class hierarchy. The Weapon namespace
   // provides common Weapon handling functions in addition to hooks
   // into the inventory system.
   className = "Weapon";

   // Basic Item properties
   shapeFile = "~/data/shapes/pistol/pistol.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = false;
   directUse = 1;
   modes = 1;
   image = pistolImage;

	// Dynamic properties defined by the scripts
   pickUpName = "a Pistol";
};

//--------------------------------------------------------------------------
// Weapon image which does all the work.  Images do not normally exist in
// the world, they can only be mounted on ShapeBase objects.
datablock ShapeBaseImageData(PistolImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/pistol/pistol.dts";
   emap = true;
   imageNum = 1;
   crosshair = "crossHair4.png";
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   eyeOffset = "0.35 0.97 -0.35";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.

   customLookAnim = "lookpistol";


   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this AssaultRifle doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Pistol;
   ammo = PistolAmmo;
   clip = PistolAmmoClip;
   projectile = PistolProjectile;
   projectileType = Projectile;
   casing = RifleShell;
   isShotGun = false;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the Pistol is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 1.1;
   stateSequence[1]                 = "Activate";

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   // Fire the Pistol. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Ready";
   stateTimeoutValue[3]             = 0.3;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateEmitter[3]                  = PistolFireEmitter;
   stateEmitterTime[3]              = 0.2;
   stateSound[3]                    = PistolFireSound;
   stateTransitionOnTriggerUp[3]    = "Ready";

   // Play the reload animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.3;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;
   stateScript[4]                   = "onReload";
   stateSound[4]                    = PistolReloadSound;

   // No ammo in the AssaultRifle, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "onReload";
   stateTransitionOnTriggerDown[5]  = "DryFire";
   stateSound[5]                    = PistolFireEmptySound;

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 0.6;
   stateTransitionOnTimeout[6]      = "NoAmmo";

   //Weapon Recoil Hooks
   recoilPitchFactor = 0.00525; //Pitch recoil
   recoilPitchRandomize = 2; //Range to randomize (-/+)
   recoilYawFactor = 0.00125; //Yaw recoil
   recoilYawRandomize = 2; //Range to randomize (-/+)
};



//-----------------------------------------------------------------------------

function PistolImage::onFire(%this, %obj, %slot)
 {
  return fireProjectile(%this, %obj, %slot);
 }

function PistolImage::onNoAmmo(%this, %obj, %slot)
{
   %obj.changeweapon(%slot + 1);
}

function PistolImage::onReload(%this, %obj, %slot)
{
}

function PistolImage::onReload(%this, %obj, %slot)
{
}

function PistolImage::ReloadAmmoClip(%this, %obj)
  {
   ReloadAmmoClip(%this, %obj, 2000);
  }
