//-----------------------------------------------------------------------------
// Torque Game Engine
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================

// Load dts shapes and merge animations

exec("~/data/shapes/players/blueplayer.cs");
exec("~/data/shapes/players/redplayer.cs");

// Timeouts for corpse deletion.
$CorpseTimeoutValue = 22 * 1000;

// Damage Rate for entering Liquid
$DamageLava       = 0.01;
$DamageHotLava    = 0.01;
$DamageCrustyLava = 0.01;

//
$PlayerDeathAnim::TorsoFrontFallForward = 1;
$PlayerDeathAnim::TorsoFrontFallBack = 2;
$PlayerDeathAnim::TorsoBackFallForward = 3;
$PlayerDeathAnim::TorsoLeftSpinDeath = 4;
$PlayerDeathAnim::TorsoRightSpinDeath = 5;
$PlayerDeathAnim::LegsLeftGimp = 6;
$PlayerDeathAnim::LegsRightGimp = 7;
$PlayerDeathAnim::TorsoBackFallForward = 8;
$PlayerDeathAnim::HeadFrontDirect = 9;
$PlayerDeathAnim::HeadBackFallForward = 10;
$PlayerDeathAnim::ExplosionBlowBack = 11;


//----------------------------------------------------------------------------
// Player Audio Profiles
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------

datablock AudioProfile(DeathCrySound)
{
   fileName = "~/data/sound/orc_death.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PainCrySound)
{
   fileName = "~/data/sound/orc_pain.ogg";
   description = AudioClose3d;
   preload = true;
};


//----------------------------------------------------------------------------

datablock AudioProfile(FootLightSoftSound)
{
   filename    = "~/data/sound/lgtstep_mono_01.ogg";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FootLightHardSound)
{
   filename    = "~/data/sound/hvystep_ mono_01.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FootLightMetalSound)
{
   filename    = "~/data/sound/metalstep_mono_01.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FootLightSnowSound)
{
   filename    = "~/data/sound/snowstep_mono_01.ogg";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FootLightShallowSplashSound)
{
   filename    = "~/data/sound/waterstep_mono_01.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FootLightWadingSound)
{
   filename    = "~/data/sound/waterstep_mono_01.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(FootLightUnderwaterSound)
{
   filename    = "~/data/sound/waterstep_mono_01.ogg";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FootLightBubblesSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ArmorMoveBubblesSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(WaterBreathMaleSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClosestLooping3d;
   preload = true;
};


//----------------------------------------------------------------------------

datablock AudioProfile(ImpactLightSoftSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClose3d;
   preload = true;
   effect = ImpactSoftEffect;
};

datablock AudioProfile(ImpactLightHardSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClose3d;
   preload = true;
   effect = ImpactHardEffect;
};

datablock AudioProfile(ImpactLightMetalSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClose3d;
   preload = true;
   effect = ImpactMetalEffect;
};

datablock AudioProfile(ImpactLightSnowSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClosest3d;
   preload = true;
   effect = ImpactSnowEffect;
};

datablock AudioProfile(ImpactLightWaterEasySound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ImpactLightWaterMediumSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ImpactLightWaterHardSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(ExitingWaterLightSound)
{
   filename    = "~/data/sound/replaceme.ogg";
   description = AudioClose3d;
   preload = true;
};


//----------------------------------------------------------------------------
// Splash
//----------------------------------------------------------------------------

datablock ParticleData(PlayerSplashMist)
{
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.05;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = false;
   spinRandomMin        = -90.0;
   spinRandomMax        = 500.0;
   textureName          = "~/data/shapes/players/splash";
   colors[0]     = "0.7 0.8 1.0 1.0";
   colors[1]     = "0.7 0.8 1.0 0.5";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 0.8;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(PlayerSplashMistEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 85;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   lifetimeMS       = 250;
   particles = "PlayerSplashMist";
};


datablock ParticleData(PlayerBubbleParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.50;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = false;
   textureName          = "~/data/shapes/players/splash";
   colors[0]     = "0.7 0.8 1.0 0.4";
   colors[1]     = "0.7 0.8 1.0 0.4";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.1;
   sizes[1]      = 0.3;
   sizes[2]      = 0.3;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(PlayerBubbleEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2.0;
   ejectionOffset   = 0.5;
   velocityVariance = 0.5;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlayerBubbleParticle";
};

datablock ParticleData(PlayerFoamParticle)
{
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.05;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = false;
   spinRandomMin        = -90.0;
   spinRandomMax        = 500.0;
   textureName          = "~/data/shapes/players/splash";
   colors[0]     = "0.7 0.8 1.0 0.20";
   colors[1]     = "0.7 0.8 1.0 0.20";
   colors[2]     = "0.7 0.8 1.0 0.00";
   sizes[0]      = 0.2;
   sizes[1]      = 0.4;
   sizes[2]      = 1.6;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(PlayerFoamEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 85;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlayerFoamParticle";
};


datablock ParticleData( PlayerFoamDropletsParticle )
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 0;
   textureName          = "~/data/shapes/players/splash";
   colors[0]     = "0.7 0.8 1.0 1.0";
   colors[1]     = "0.7 0.8 1.0 0.5";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.8;
   sizes[1]      = 0.3;
   sizes[2]      = 0.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( PlayerFoamDropletsEmitter )
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 60;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientParticles  = true;
   particles = "PlayerFoamDropletsParticle";
};


datablock ParticleData( PlayerSplashParticle )
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 0;
   colors[0]     = "0.7 0.8 1.0 1.0";
   colors[1]     = "0.7 0.8 1.0 0.5";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 0.5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( PlayerSplashEmitter )
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 60;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "PlayerSplashParticle";
};

datablock SplashData(PlayerSplash)
{
   numSegments = 15;
   ejectionFreq = 15;
   ejectionAngle = 40;
   ringLifetime = 0.5;
   lifetimeMS = 300;
   velocity = 4.0;
   startRadius = 0.0;
   acceleration = -3.0;
   texWrap = 5.0;

   texture = "~/data/shapes/players/splash";

   emitter[0] = PlayerSplashEmitter;
   emitter[1] = PlayerSplashMistEmitter;

   colors[0] = "0.7 0.8 1.0 0.0";
   colors[1] = "0.7 0.8 1.0 0.3";
   colors[2] = "0.7 0.8 1.0 0.7";
   colors[3] = "0.7 0.8 1.0 0.0";
   times[0] = 0.0;
   times[1] = 0.4;
   times[2] = 0.8;
   times[3] = 1.0;
};


//----------------------------------------------------------------------------
// Foot puffs
//----------------------------------------------------------------------------

datablock ParticleData(LightPuff)
{
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.01;
   inheritedVelFactor   = 0.6;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = true;
   spinRandomMin        = -35.0;
   spinRandomMax        = 35.0;
   colors[0]     = "1.0 1.0 1.0 1.0";
   colors[1]     = "1.0 1.0 1.0 0.0";
   sizes[0]      = 0.1;
   sizes[1]      = 0.8;
   times[0]      = 0.3;
   times[1]      = 1.0;
};

datablock ParticleEmitterData(LightPuffEmitter)
{
   ejectionPeriodMS = 35;
   periodVarianceMS = 10;
   ejectionVelocity = 0.2;
   velocityVariance = 0.1;
   ejectionOffset   = 0.0;
   thetaMin         = 20;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   useEmitterColors = true;
   particles = "LightPuff";
};

//----------------------------------------------------------------------------
// Liftoff dust
//----------------------------------------------------------------------------

datablock ParticleData(LiftoffDust)
{
   dragCoefficient      = 1.0;
   gravityCoefficient   = -0.01;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 500.0;
   colors[0]     = "1.0 1.0 1.0 1.0";
   sizes[0]      = 1.0;
   times[0]      = 1.0;
};

datablock ParticleEmitterData(LiftoffDustEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 2.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 90;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   useEmitterColors = true;
   particles = "LiftoffDust";
};


//----------------------------------------------------------------------------

datablock DecalData(PlayerFootprint)
{
   sizeX       = 0.20;
   sizeY       = 0.20;
   textureName = "~/data/shapes/players/footprint";
};

datablock DebrisData( PlayerDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};

datablock PlayerData(PlayerBody)
{
   //renderFirstPerson = true; //Ari's FPS Hack
   renderFirstPerson = false;
   emap = true;

   useWeaponBackFraction = "1";

   className = Armor;
   shapeFile = "~/data/shapes/players/player.dts";
   cameraMaxDist = 3;
   computeCRC = false;

   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;

   debrisShapeName = "~/data/shapes/players/debris_player.dts";
   debris = playerDebris;

   aiAvoidThis = true;

   minLookAngle = -1.4;
   maxLookAngle = 1.4;
   maxFreelookAngle = 4.0;

   mass = 11;
   drag = 0.3;
   maxdrag = 0.4;
   density = 10;
   maxDamage = 100;
   maxEnergy =  60;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.256;

   runForce = 48 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 11;
   maxBackwardSpeed = 7;
   maxSideSpeed = 8;

   maxUnderwaterForwardSpeed = 1.4;
   maxUnderwaterBackwardSpeed = 1.8;
   maxUnderwaterSideSpeed = 1.8;

   jumpForce = 8.3 * 10;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 15;

   recoverDelay = 9;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 45;
   speedDamageScale = 0.4;

   boundingBox = "1.2 1.5 2.5";
   pickupRadius = 0.75;

   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   decalData   = PlayerFootprint;
   decalOffset = 0.10;

   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.4;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 70;
   jumpSurfaceAngle = 80;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;

   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   // Footstep Sounds
   FootSoftSound        = FootLightSoftSound;
   FootHardSound        = FootLightHardSound;
   FootMetalSound       = FootLightMetalSound;
   FootSnowSound        = FootLightSnowSound;
   FootShallowSound     = FootLightShallowSplashSound;
   FootWadingSound      = FootLightWadingSound;
   FootUnderwaterSound  = FootLightUnderwaterSound;

   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;

   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;

   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;

   //exitingWater         = ExitingWaterLightSound;

   observeParameters = "0.5 4.5 4.5";
   iconType = $PersonIcon;
   minCollisionSpeed = 15;  // if anything runs into a player with speed > 15, we take damage

   // inventory for basic loads
   maxInv[PistolAmmo] = PistolAmmo.maxInventory;
   maxInv[PistolAmmoClip] = PistolAmmoClip.MaxInventory;
   maxInv[Pistol] = 1;
   maxInv[Knife] = 1;
   maxInv[Grenade] = 1;
   maxInv[GrenadeAmmo] = GrenadeAmmo.maxInventory;
};

datablock PlayerData(PlayerTeam1 : PlayerBody)
 {
  teamid=1;
  shapeFile = "~/data/shapes/players/redplayer.dts";
  // other team 1 specific stuff goes here
};

datablock PlayerData(PlayerTeam2 : PlayerBody)
 {
  teamid=2;
  shapeFile = "~/data/shapes/players/blueplayer.dts";
  // other team 2 specific stuff goes here
};


datablock PlayerData(PlayerBody1Class1 : PlayerTeam1)
{
   maxInv[SniperRifleAmmo] = SniperRifleAmmo.maxInventory;
   maxInv[SniperRifleAmmoClip] = SniperRifleAmmoClip.maxInventory;
   maxInv[SniperRifle] = 1;
   maxInv[APMineAmmo] = APMine.maxInventory;
   maxInv[APMine] = 1;

};

datablock PlayerData(PlayerBody1Class2 : PlayerTeam1)
{
   maxInv[MachineGunAmmo] = MachineGunAmmo.maxInventory;
   maxInv[MachineGunAmmoClip] = MachineGunAmmoClip.maxInventory;
   maxInv[MachineGun] = 1;
   maxInv[AmmoPack] = 1;
   maxInv[AmmoPackAmmo] = AmmoPackAmmo.maxInventory;
};

datablock PlayerData(PlayerBody1Class3 : PlayerTeam1)
{
   maxInv[ShotgunAmmo] = ShotgunAmmo.maxInventory;
   maxInv[ShotgunAmmoClip] = ShotgunAmmoClip.maxInventory;
   maxInv[Shotgun] = 1;
   maxInv[RepairTool] = 1;
   maxInv[AVMineAmmo] = AvMineAmmo.maxInventory;
   maxInv[AVMine] = 1;
};

datablock PlayerData(PlayerBody1Class4 : PlayerTeam1)
{
   maxInv[RifleAmmo] = RifleAmmo.maxInventory;
   maxInv[RifleAmmoClip] = RifleAmmoClip.maxInventory;
   maxInv[Rifle] = 1;
   maxInv[MedicPack] = 1;
   maxInv[MedicPackAmmo] = MedicPackAmmo.maxInventory;
};

datablock PlayerData(PlayerBody1Class5 : PlayerTeam1)
{
   maxInv[AssaultRifleAmmo] = AssaultRifleAmmo.maxInventory;
   maxInv[AssaultRifleAmmoClip] = AssaultRifleAmmoClip.maxInventory;
   maxInv[AssaultRifle] = 1;
   maxInv[AssaultGrenadeAmmo] = AssaultGrenadeAmmo.maxInventory;
};

datablock PlayerData(PlayerBody1Class6 : PlayerTeam1)
{
   maxInv[SMGAmmo] = SMGAmmo.maxInventory;
   maxInv[SMGAmmoClip] = SMGAmmoClip.maxInventory;
   maxInv[SMG] = 1;
   maxInv[RocketLauncher]     = 1;
   maxInv[RocketLauncherAmmo] = RocketLauncherAmmo.maxInventory;
   maxInv[C4] = 1;
   maxInv[C4Ammo] = C4Ammo.maxInventory;
};

datablock PlayerData(PlayerBody2Class1 : PlayerTeam2)
{
   maxInv[SniperRifleAmmo] = SniperRifleAmmo.maxInventory;
   maxInv[SniperRifleAmmoClip] = SniperRifleAmmoClip.maxInventory;
   maxInv[SniperRifle] = 1;
   maxInv[APMineAmmo] = APMineAmmo.maxInventory;
   maxInv[APMine] = 1;
};

datablock PlayerData(PlayerBody2Class2 : PlayerTeam2)
{
   maxInv[MachineGunAmmo] = MachineGunAmmo.maxInventory;
   maxInv[MachineGunAmmoClip] = MachineGunAmmoClip.maxInventory;
   maxInv[MachineGun] = 1;
   maxInv[AmmoPack] = 1;
   maxInv[AmmoPackAmmo] = AmmoPackAmmo.maxInventory;
};

datablock PlayerData(PlayerBody2Class3 : PlayerTeam2)
{
   maxInv[ShotgunAmmo] = ShotgunAmmo.maxInventory;
   maxInv[ShotgunAmmoClip] = ShotgunAmmoClip.maxInventory;
   maxInv[Shotgun] = 1;
   maxInv[RepairTool] = 1;
   maxInv[AVMineAmmo] = AVMineAmmo.maxInventory;
   maxInv[AVMine] = 1;
};

datablock PlayerData(PlayerBody2Class4 : PlayerTeam2)
{
   maxInv[RifleAmmo] = RifleAmmo.maxInventory;
   maxInv[RifleAmmoClip] = RifleAmmoClip.maxInventory;
   maxInv[Rifle] = 1;
   maxInv[MedicPack] = 1;
   maxInv[MedicPackAmmo] = MedicPackAmmo.maxInventory;
};

datablock PlayerData(PlayerBody2Class5 : PlayerTeam2)
{
   maxInv[AssaultRifleAmmo] = AssaultRifleAmmo.maxInventory;
   maxInv[AssaultRifleAmmoClip] = AssaultRifleAmmoClip.maxInventory;
   maxInv[AssaultRifle] = 1;
   maxInv[AssaultGrenadeAmmo] = AssaultGrenadeAmmo.maxInventory;
};

datablock PlayerData(PlayerBody2Class6 : PlayerTeam2)
{
   maxInv[SMGAmmo] = SMGAmmo.maxInventory;
   maxInv[SMGAmmoClip] = SMGAmmoClip.maxInventory;
   maxInv[SMG] = 1;
   maxInv[RocketLauncher]     = 1;
   maxInv[RocketLauncherAmmo] = RocketLauncherAmmo.maxInventory;
   maxInv[C4] = 1;
   maxInv[C4Ammo] = C4Ammo.maxInventory;
};

//----------------------------------------------------------------------------
// Armor Datablock methods
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------

function Armor::onAdd(%this,%obj)
{
   // Vehicle timeout
   %obj.mountVehicle = true;

   // Default dynamic armor stats
   %obj.setRechargeRate(%this.rechargeRate);
   %obj.setRepairRate(0);
}

function Armor::onRemove(%this, %obj)
{
   if (%obj.client.player == %obj)
      %obj.client.player = 0;
   //Starter.Combat
   // free mounted turret
   if (isObject(%obj.mountedTurret))
   {
      %obj.mountedTurret.schedule(300,"delete");
      MissionCleanup.Add(%obj.mountedTurret);
   }
   //Starter.Combat
}

function Armor::onNewDataBlock(%this,%obj)
{
}


//----------------------------------------------------------------------------

function Armor::onMount(%this,%obj,%vehicle,%node)
{
	//Starter.Combat
   %vehicle.setTeam(%obj.team.teamId);
   %obj.mVehicle = %vehicle;
   %seat = extractSeatFromNode(%vehicle, %node);
   onPlayerMount(%this,%obj,%vehicle,%seat);

   // setup default values
   %crosshairImage = "none";
   %showDials = 0;
   %weaponViews = 0;
   %cam = $eyeView;

   // get turret crosshairs from the turret object
   if ( %vehicle.turretNode[%seat])
      %crosshairImage = %vehicle.turretNode[%seat].getDataBlock().crosshair;

   //seat 0 is always the driver, so show the dials
   if ( %seat == 0) %showDials = 1;

   // set the proper control object
   if ( %seat ==0)
     {
      %obj.client.setControlObject(%vehicle);
      %weaponViews = %vehicle.weaponviews;
      %cam = %vehicle.defaultCam;
     }
   else
     {
      if (%vehicle.turretNode[%seat])
        %obj.setControlObject(%vehicle.turretNode[%seat]);
      else
        %obj.setControlObject(%obj);
     }

   // update client with the results
   commandToClient(%obj.client, 'SetWeaponViews', %weaponViews, %cam, %showDials, %crosshairImage);
}

function Armor::onUnmount( %this, %obj, %vehicle, %node )
{
   %seat = extractSeatFromNode(%vehicle, %node);
   onPlayerUnmount(%this, %obj, %vehicle, %seat);

   if (%seat == 0) //Pilot Only
   {
      %client = %obj.client;
      %whichgui = %vehicle.vehicleType;
      commandtoclient(%client, 'closegui', %whichgui);
      %client.setControlObject(%obj);
   }

}

//----------------------------------------------------------------------------

function Armor::onCollision(%this,%obj,%col, %vec)
  {
   if (%obj.getState() $= "Dead")
      return;

   // Try and pickup all items
   if (%col.getClassName() $= "Item")
      return( %obj.pickup(%col) );
  }

function Armor::onImpact(%this, %obj, %collidedObject, %vec, %vecLen)
{
   %obj.damage(0, VectorAdd(%obj.getPosition(),%vec),
      %vecLen * %this.speedDamageScale, "Impact");
}

//----------------------------------------------------------------------------

function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType, %damageLoc)
{
   echo("Armor::damage data: " @ %this @ " obj: " @ %obj @ " source: " @ %sourceObject @ " amt: " @ %damage @ " type: " @ %damageType);
   if (%obj.getState() $= "Dead")
      return;

   if(%damageLoc $= "")
      %location = "Body";
   else
      %location = %damageLoc;
   %obj.damageType = %damageType;
   %obj.damageDirection = getWord(%obj.getDamageLocation(%position),1);
   %obj.damageSeverity = %damage;
   
   // Deal with client callbacks here because we don't have this
   // information in the onDamage or onDisable methods
   %client = %obj.client;
   if (%sourceObject.client)
     %sourceClient = %sourceObject.client;
   else
     %sourceClient = %sourceObject;

   // friendly fire handling. type = Override used to bypass friendly fire settings
   if (%damageType !$= "Override")
     if (%sourceClient.team.teamid == %client.team.teamid)
       if (%sourceClient != %client)
         if ( $Game::FriendlyFire == false)
           {
            echo("Ignoring friendly fire");
            return;
           }

   %obj.applyDamage(%damage);

   if (%obj.getState() $= "Dead")
     {
      %obj.disableCollision();
      %client.schedule(0, "onDeath", %sourceObject, %sourceClient, %damageType, %location);
     }
}

function Armor::onDamage(%this, %obj, %delta)
{
   // This method is invoked by the ShapeBase code whenever the
   // object's damage level changes.
   if (%delta > 0 && %obj.getState() !$= "Dead") {

      // Increment the flash based on the amount.
      %flash = %obj.getDamageFlash() + ((%delta / %this.maxDamage) * 2);
      if (%flash > 0.75)
         %flash = 0.75;
      %obj.setDamageFlash(%flash);

      // If the pain is excessive, let's hear about it.
      if (%delta > 10)
         %obj.playPain();
   }
}

function Armor::onDisabled(%this,%obj,%state)
{
   // The player object sets the "disabled" state when damage exceeds
   // it's maxDamage value.  This is method is invoked by ShapeBase
   // state mangement code.

   // If we want to deal with the damage information that actually
   // caused this death, then we would have to move this code into
   // the script "damage" method.
   %obj.playDeathCry();
   %obj.playDeathAnimation();
   %obj.setDamageFlash(0.75);

   // Release the main weapon trigger
   %obj.setImageTrigger(0,false);
   %obj.setImageTrigger(1,false);

   // Schedule corpse removal.  Just keeping the place clean.
   %obj.schedule($CorpseTimeoutValue - 1000, "startFade", 1000, 0, true);
   %obj.schedule($CorpseTimeoutValue, "delete");
}


//-----------------------------------------------------------------------------

function Armor::onLeaveMissionArea(%this, %obj)
{
   // Inform the client
   %obj.client.onLeaveMissionArea();
}

function Armor::onEnterMissionArea(%this, %obj)
{
   // Inform the client
   %obj.client.onEnterMissionArea();
}

//-----------------------------------------------------------------------------

function Armor::onEnterLiquid(%this, %obj, %coverage, %type)
{
   switch(%type)
   {
      case 0: //Water
      case 1: //Ocean Water
      case 2: //River Water
      case 3: //Stagnant Water
      case 4: //Lava
         %obj.setDamageDt(%this, $DamageLava, "Lava");
      case 5: //Hot Lava
         %obj.setDamageDt(%this, $DamageHotLava, "Lava");
      case 6: //Crusty Lava
         %obj.setDamageDt(%this, $DamageCrustyLava, "Lava");
      case 7: //Quick Sand
   }
}

function Armor::onLeaveLiquid(%this, %obj, %type)
{
   %obj.clearDamageDt();
}


function Armor::onStartClimb(%this, %obj, %ClimbObject)
{
   //Dismount the weapon here
   %obj.lastWeapon = %obj.getMountedImage($WeaponSlot);
   %obj.unmountImage($WeaponSlot);
   %obj.setArmThread("look");

   //Pick Action Animation Based on Object Type
   if(%climbObject.ClimbAnim $= "")
      %obj.setActionThread("Climbing1");
   else
      %obj.setActionThread(%climbObject.ClimbAnim);
}

function Armor::onEndClimb(%this, %obj)
{
   //Remount the previous weapon here
   %obj.mountImage(%obj.lastWeapon, $WeaponSlot);
   %obj.setArmThread(%obj.lastWeapon.customLookAnim);
}



//-----------------------------------------------------------------------------

function Armor::onTrigger(%this, %obj, %triggerNum, %val)
{
   // This method is invoked when the player receives a trigger
   // move event.  The player automatically triggers slot 0 and
   // slot one off of triggers # 0 & 1.  Trigger # 2 is also used
   // as the jump key.
}

//-----------------------------------------------------------------------------
// Player methods
//-----------------------------------------------------------------------------

//----------------------------------------------------------------------------

function Player::kill(%this, %damageType)
{
   %this.damage(%this, %this.getPosition(), 10000, %damageType);
}


//----------------------------------------------------------------------------

function Player::mountVehicles(%this,%bool)
{
   // If set to false, this variable disables vehicle mounting.
   %this.mountVehicle = %bool;
}

function Player::isPilot(%this)
{
   %vehicle = %this.getObjectMount();
   // There are two "if" statements to avoid a script warning.
   if (%vehicle)
      if (%vehicle.getMountNodeObject(0) == %this)
         return true;
   return false;
}


//----------------------------------------------------------------------------

function Player::playDeathAnimation(%this)
{
   //Test cases for particular damage types, which are passed through from the onCollisions to the ::damage routine
   if(%this.damageDirection !$= "")
   {
      switch$(%this.damageDirection)
      {
         case "middle_back": %death = "front_";
         case "right_back": %death = "front_";
         case "left_back": %death = "front_";
         case "back_left": %death = "front_";
         case "back_right": %death = "front_";
         case "right_front": %death = "back_";
         case "left_front": %death = "back_";
         case "front_right": %death = "back_";
         case "front_left": %death = "back_";
         case "middle_front": %death = "back_";
         case "middle_middle": %death = "back_";
         case "left_middle": %death = "right_";
         case "right_middle": %death = "left_";
      }
      
      if(%this.damageSeverity > 0)
         %deathnum = 1;               
      if(%this.damageSeverity > 35)
         %deathnum = 2;               
      if(%this.damageSeverity > 50)
         %deathnum = 3;         
      if(%this.damageSeverity > 100)
         %deathnum = 4;

      %deathanim = %death @ %deathnum;
      echo("Death anim:" @ %deathanim);
      %this.setActionThread(%deathanim);
   } else {
      
      switch$(%this.damageType){
         case "head":
            %this.deathIdx = 3;
         case "explode":
            %this.deathIdx = 4;
      }

      if(%this.deathidx $="")
         %this.deathidx = getRandom(1,4);

      if(%this.deathidx<1)
         %this.deathidx = getRandom(1,4);

      %this.setActionThread("Death" @ %this.deathidx);
   }
}

function Player::playCelAnimation(%this,%anim)
{
   if (%this.getState() !$= "Dead")
      %this.setActionThread("cel"@%anim);
}


//----------------------------------------------------------------------------

function Player::playDeathCry( %this )
{
   %this.playAudio(0,DeathCrySound);
}

function Player::playPain( %this )
{
   %this.playAudio(0,PainCrySound);
}

// phdana turrets ->
// if you dont already have this for vehicles
// you need it for turrets
function findEmptySeat(%vehicle, %vehicleblock)
{
  for (%i = 0; %i <  %vehicleblock.numMountPoints; %i++)
  {
    %node = %vehicle.getMountNodeObject(%i);
    if (%node == 0)
    {
         return %i;
    }
  }
  return -1;
}
// <- phdana turrets

function Armor::onChuteOpen(%this, %obj)
{
  %obj.onChuteOpen();
}

function Armor::onChuteClose(%this, %obj)
{
  %obj.onChuteClose();
}

function Player::onChuteOpen(%this)
{
  if(%this.parachute)
     return;

  %this.parachute = new StaticShape()
	{
		dataBlock = Parachute;
	};

	// see ShapeBase::mountObject in shapeBase.cc for info on the new mountObject changes
  %this.mountObject(%this.parachute,0, "0 0 0", "Bip01_Spine1");
  %this.parachute.PlayThread(0,"open");
}

function Player::onChuteClose(%this)
{
  //uncomment to use the parachute's billowing down thread
  //%this.parachute.PlayThread(0,"down");
  //%this.Schedule( 1500, 0,  removeParachute);
  %this.removeParachute();
  
}

function Player::removeParachute(%this)
{
 	%this.unMountObject(%this.parachute);
	%this.parachute.delete();
	%this.parachute = "";
}

function reloadplayer(){
   exec("starter.combat/server/scripts/player.cs");
}

function Player::AddWeapon(%player, %weapon, %slot, %mount)
  {
   %player.setInventory(%weapon, 1);
   %player.weaponSlot[%slot] = %weapon;
   %player.weaponSlotFilled[%slot] = true;

   if (%mount)
     {
      %player.mountImage(%weapon, 0);
      %player.ActiveWeaponSlot = %slot;
     }
  }

// set the basic weapon load for this player
// knife, pistol and 4 grenades
function Player::SetBasicWeaponLoad(%this)
  {
   %this.setInitialInventory(PistolAmmo);
   %this.setInitialInventory(PistolAmmoClip);
   %this.setInitialInventory(GrenadeAmmo);
   %this.addWeapon(Knife, 1, false);
   %this.addWeapon(Pistol, 2, true);
   %this.addWeapon(Grenade, 4, false);
  }

// set starting inventory for an ammo-like object
// set the inventory to 'full' - as defined in the object's datablock
function Player::setInitialInventory(%this, %datablock)
  {
   %this.setInventory(%datablock, %datablock.maxInventory);
  }

function ServerCmdChangeWeapon(%client, %slot)
  {
   %client.player.changeweapon(%slot);
  }

function Player::ChangeWeapon(%player, %slot)
  {
   %player.lastSlot = %slot;
   if (%player.weaponSlotFilled[%slot])
     {
      %weapon = %player.weaponSlot[%slot];

      %player.unMountImage(%player.activeWeaponSlot);
      %player.ActiveWeaponSlot = %slot;
      %player.MountImage(%weapon.image, 0);

      %weaponimage = %weapon.image;

     if(%weaponimage.ammo !$="")
     {
        if (%player.getInventory(%weaponimage.ammo) <= 0)
        {
            ReloadAmmoClip(%weapon, %player);
        }
     }

      if (%weaponimage.customLookAnim !$= "")
         %player.setArmThread(%weaponimage.customLookAnim);
      else
         %player.setArmThread("looknw");

     }
   else
     {
      echo("NO weapon in slot" SPC %slot);
     }
  }
