// ============================================================
// Copyright 2007 Dream Games, Inc.
// Combat Starter Kit
// ============================================================


datablock AudioProfile(TankGunFireSound)
{
filename = "~/data/sound/artillery_1.ogg";
description = AudioClose3d;
preload = true;
};

datablock ItemData(TankAmmo) //Duncan - I put this here temporary because someone deleted the original
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "~/data/shapes/crossbow/ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;

   // Dynamic properties defined by the scripts
   pickUpName = "Tank Ammo";
   maxInventory = 20;
};
datablock ProjectileData(Tank01TurretProjectile)
{
   projectileShapeName = "~/data/shapes/turrets/Tprojectile.dts";
   directDamage        = 1500;
   radiusDamage        = 100;
   damageRadius        = 12;
   areaImpulse         = 2000;

   explosion           = TankShellExplosion;

   particleEmitter     = M60SmokeEmitter;
   splash              = BulletSplash;

   muzzleVelocity      = 700;
   velInheritFactor    = 0.3;

   armingDelay         = 0;
   lifetime            = 5000;
   fadeDelay           = 5000;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.80;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0.5 0.5 0.25";

   hasWaterLight     = true;
   waterLightColor   = "0 0.5 0.5";
};

datablock ShapeBaseImageData(TurretGun)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/turrets/mainTurretGun.dts";
   mass = 15;

   mountPoint = 3;
   offset = "0 0 0";
   ammo = TankAmmo;
   projectile = Tank01TurretProjectile;
   projectileType = Projectile;
   correctMuzzleVector = true;    // fire at what the cam node looks at

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
      // State transitions
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 2.01;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Fire";
   stateTransitionOnTimeout[2]      = "Reload";
   stateTimeoutValue[2]             = 1.0;
   stateFire[2]                     = true;
   stateRecoil[2]                   = LightRecoil;
   stateAllowImageChange[2]         = false;
   stateSequence[2]                 = "Fire";
   stateSound[2]                    = TankGunFireSound;
   stateScript[2]                   = "onFire";

   stateName[3]                     = "Reload";
   stateTimeoutValue[3]             = 1.4;
   stateAllowImageChange[3]         = false;
   stateTransitionOnTimeout[3]      = "Ready";
   stateTransitionOnNoAmmo[3]       = "NoAmmo";

   stateName[4]                     = "NoAmmo";
   stateTransitionOnAmmo[4]         = "Reload";
   stateSequence[4]                 = "NoAmmo";

};
datablock AudioProfile(TankEngineSound)
{
   filename    = "~/data/sound/combat/engine_idle.ogg";
   description = AudioClosestLooping3d;
   preload = true;
};
datablock WheeledVehicleTire(Tank01Tire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "~/data/shapes/combat/tankWheel.dts";
   staticFriction = 3.1;
   kineticFriction = 2.5;

   // Spring that generates lateral tire forces
   lateralForce = 18000;
   lateralDamping = 6000;
   lateralRelaxation = 1;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 18000;
   longitudinalDamping = 4000;
   longitudinalRelaxation = 1;
   trackThickness = 0.15;
};

datablock WheeledVehicleSpring(Tank01Spring)
{
   // Wheel suspension properties
   length = 0.9;              // Suspension travel
   force = 5000;              // Spring force
   damping = 1500;            // Spring damping
   antiSwayForce = 6;         // Lateral anti-sway force
};
datablock WheeledVehicleData(Tank01:BaseWheeledVehicle)
{
   category = "Vehicles";
   shapeFile = "~/data/shapes/combat/tank01.dts";
   debrisShapeName = "~/data/shapes/combat/tankDebris.dts";
   emap = true;
   className = Tank01Data;

   // The array numbers below must be sequencial from 0 to numMountPoints -1
   // It does not matter HERE how your mount points are defined in the model
   // check the ::onAdd function to see where you map sequencial seat numbers
   // to your actual numbered mountpoints
   numMountPoints      = 2;

   mountPose[0]             = "Sitting";
   mountPointTransform[0]   = "0 0 0 0 0 1 0";
   isProtectedMountPoint[0] = true;

   mountPose[1]             = "Sitting";
   mountPointTransform[1]   = "0 0 0 0 0 1 0";
   isProtectedMountPoint[0] = false;


   maxDamage = 5000.0;
   destroyedLevel = 5000;

   maxSteeringAngle = 0.75;//0.485;  // Maximum steering angle

   // Rigid Body
   mass = 640;

   // Engine
   engineTorque = 800;       // Engine power
   maxRevs = 90.0;           // percentage value indicating how high the engine can rev
   // a space separated list of float values to multiply the engineTorque with.  Max of 12 gears allowed
   Gears = "4.0 2.14 1.36 0.937 0.75 0.5 0.365";
   engineBrake = 800;         // Braking when throttle is 0
   brakeTorque = 3200;        // When brakes are applied
   maxWheelSpeed = 60;        // Engine scale by current speed / max speed
   engineSound = TankEngineSound;

   // Energy
   maxEnergy = 100;

   maxInv[TankAmmo]           = TankAmmo.maxInventory;

   ArmorValue = 50;        // damage must be above this amount to have any effect.
   EnglishName = "Tank";


   UVspeedScale = 1.5; // for the tank tread animation
   damageEmitterOffset[0]  = "0.0 -11.5 3 ";
   damageEmitterOffset[1]  = "0.0 -10.0 5 ";


   maxPitchSpeed = 200.0; // barrel up/down degrees/second
   maxYawSpeed = 100.0;   // rotate degrees/second
   minPitch = -5; // down angle
   maxPitch = 85; // up angle
   // set these to zero if you want unlimited rotation
   minYaw = 0;   // we speak of the constraints on yaw as if it's range
   maxYaw = 0;    // were -180/180 even tho it's actually stored as 0..360

   // Explosion
   directDamage = 1000;
   damageRadius = 40;
   radiusDamage = 100;
   areaImpulse = 100;

   iconType = $TankIcon;
   speedDamageScale = 7;
   minCollisionSpeed = 10; // anything colliding with the tank above this speed will do damage
   collisionMass = 1200;   // 60 tons (weight of M1 tank courtesy of google)

};

datablock StaticShapeData (TankBody)
{
   category = "Vehicles";
   shapeFile = "~/data/shapes/combat/tankBody.dts";
   emap = true;
};
datablock StaticShapeData (TankTurret01)
{
   category = "Vehicles";
   shapeFile = "~/data/shapes/turrets/tankturret.dts";
   emap = true;
   crosshair = "TurretScope.png";
   barrel = TurretGun; // needed for compatability with setInitialAmmo in vehicles
   maxInv[TurretGun.ammo] = TurretGun.ammo.maxInventory;
};

function Tank01::create(%block)
{
   %obj = new TankVehicle() {
      dataBlock = %block;
   };
   return(%obj);
}


function Tank01::onAdd(%this,%obj)
{
   Parent::onAdd(%this, %obj);

   // Setup the car with some defaults tires & springs
   %wcount = %obj.getWheelCount();
   for (%i = %wcount - 1; %i >= 0; %i--) {
      %obj.setWheelTire(%i,Tank01Tire);
      %obj.setWheelSpring(%i,Tank01Spring);
      %obj.setWheelPowered(%i,true);
   }

   // set up steering --------------------------------
   %wfac = 4/(%wcount-2);
   %wangle = 1;
   %k=0;
   for (%i = (%wcount - 1)/2; %i >= 0; %i--)
   {
      for(%j=0;%j<2;%j++){
         %obj.setWheelSteering(%k,%wangle);
         %k++;
      }
      %wangle -= %wfac;
   }

   // set some mount values to use later -------------------
   %turretMountNode = 2;
   %barrelMountNode = 3; // check that the weaponImage mountPoint agrees with this
   %barrelMountSlot = 0; // note, this is a SLOT
   %machineGunMountNode = 4;
   %tankBodyMountNode = 5;

   // mount the turret shape --------------------------
   %turret = new StaticShape()
   {
      dataBlock = TankTurret01;
   };
   %obj.mountObject(%turret,%turretMountNode);
   %obj.Turret = %turret;  //used to delete the turret in onRemove

   // tell player.cs to display crosshairs for seat 0
   %obj.turretNode[0] = %turret;

   //mount the turret weapon ---------------------------
   // this must happen BEFORE setTurretNodes
   %obj.mountImage(TurretGun,%barrelMountSlot);

   // tell the vehicle class which nodes to animate -------
   %obj.setTurretNodes(%turretMountNode,%barrelMountNode);

   //-------- mount a machine gun turret ------------------
   %machinegun = new Turret()
   {
      dataBlock = GenericTurret;
   };

   %obj.mountObject(%machinegun,%machineGunMountNode);
   %obj.mountedTurret = %machinegun;
   // The following command tells player.cs onMount to assign this turret control
   // to the person seated at the seat number in the square brackets
   %obj.turretNode[1] = %machinegun;

   //-------mount the tank body ----------------------

   %body = new StaticShape()
   {
      dataBlock = TankBody;
   };
   %obj.mountObject(%body,%tankBodyMountNode);
   %obj.body = %body;
   //--------------------------------------------------

   %obj.setInventory(TankAmmo, TankAmmo.maxInventory);
   // the weapon views are exclusively for the driver/pilot of the vehicle
   // how many weapons does he control?
   %obj.weaponviews = 1; //used in player.cs onMount


   // The scripting functions expect the player seating mount points
   // to be sequencial from 0 to numMountPoints.  Unfortunately
   // that does not always agree with the actual model layout
   // we thus map the seat to the mountpoint in an array
   %obj.seat[0] = 0;
   %obj.seat[1] = 1;

   %obj.defaultCam = $weaponView;  // see top of vehicle.cs

   %obj.SpawnPos = %obj.position;
   %obj.SpawnRot = %obj.rotation;
}

function Tank01::onRemove(%this, %obj)
  {
   if (isObject(%obj.Turret) )
     %obj.Turret.delete();

   if (isObject(%obj.body))
     %obj.body.delete();

   if (isObject(%obj.mountedTurret))
     %obj.mountedTurret.delete();

}

// default callback from the engine
// deferr to generic impact function
function Tank01::onImpact(%this, %obj, %collide, %vec, %vecLen)
 {
  doVehicleImpact(%this, %obj, %collide, %vec, %vecLen);
 }

// Tank has been destroyed, delete carcas, and schedule a respawn
function Tank01::onDestroyed(%data, %obj, %prevState)
 {
  %obj.schedule($Vehicle::CorpseTimeout, "delete");

  // schedule a respawn
  %db = %obj.getDataBlock();
  %pos = %obj.SpawnPos;
  %rot = %obj.SpawnRot;
  if (%db.RespawnTimer)
     Schedule( (%db.RespawnTimer * 1000) + $Vehicle::CorpseTimeout, MissionGroup, "RespawnVehicle", "TankVehicle", %db.getName() , %pos, %rot);
 }

// default callback from the engine
// deferr to generic collision function
function Tank01::onCollision(%this,%obj,%col,%vec,%speed)
{
   // Collision with other objects, including items
   doVehicleCollision(%this,%obj,%col,%vec,%speed);
}
   // send the initial ammo settings to %client
function Tank01::initialAmmo(%this, %client, %seat)
  {
   %turret = %this.turretNode[%seat];
   if (%turret)
     {
      // get ammo name and max values from whatever turret-like thing is the player is controlling
      %ammo = %turret.dataBlock.barrel.ammo;

      if (%turret.getClassName() $= "Turret")
        %currentAmmo = %turret.getInventory(%ammo);
      else
        // tank is different here in that the ammo is stored in the tank body instead of the turret object
        %currentAmmo = %this.getInventory(%ammo);

      %client.setVehicleAmmo(%currentAmmo, %turret.getDataBlock().maxInv[%ammo], %ammo);
     }
   else
     %client.setVehicleAmmo(0, 0, "none");

  }

function Tank01TurretProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   // Apply damage to the object all shape base objects
   if (%col.getType() & $TypeMasks::ShapeBaseObjectType)
     {
      if (strstr(%col.getClassName(), "heli") != -1)
        // tank shell vs helicopter == boom
        %col.damage(%obj,%pos, DefaultHeli.maxDamage, %this.getName() );
      else
        %col.damage(%obj,%pos,%this.directDamage, %this.getName() );
     }
   // Radius damage is a support scripts defined in radiusDamage.cs
   // Push the contact point away from the contact surface slightly
   // along the contact normal to derive the explosion center. -dbs
   radiusDamage(%obj, %pos, %this.damageRadius, %this.radiusDamage, "Radius", %this.areaImpulse);
}

function TurretGun::onFire(%this, %obj, %slot)
  {
   return fireProjectile(%this, %obj, %slot);
  }
